/* [MS-XLSB] 2.3 Record Enumeration */
var XLSBRecordEnum = {
	/*::[*/0x0000/*::]*/: { n:"BrtRowHdr", f:parse_BrtRowHdr },
	/*::[*/0x0001/*::]*/: { n:"BrtCellBlank", f:parse_BrtCellBlank },
	/*::[*/0x0002/*::]*/: { n:"BrtCellRk", f:parse_BrtCellRk },
	/*::[*/0x0003/*::]*/: { n:"BrtCellError", f:parse_BrtCellError },
	/*::[*/0x0004/*::]*/: { n:"BrtCellBool", f:parse_BrtCellBool },
	/*::[*/0x0005/*::]*/: { n:"BrtCellReal", f:parse_BrtCellReal },
	/*::[*/0x0006/*::]*/: { n:"BrtCellSt", f:parse_BrtCellSt },
	/*::[*/0x0007/*::]*/: { n:"BrtCellIsst", f:parse_BrtCellIsst },
	/*::[*/0x0008/*::]*/: { n:"BrtFmlaString", f:parse_BrtFmlaString },
	/*::[*/0x0009/*::]*/: { n:"BrtFmlaNum", f:parse_BrtFmlaNum },
	/*::[*/0x000A/*::]*/: { n:"BrtFmlaBool", f:parse_BrtFmlaBool },
	/*::[*/0x000B/*::]*/: { n:"BrtFmlaError", f:parse_BrtFmlaError },
	/*::[*/0x000C/*::]*/: { n:"BrtShortBlank", f:parse_BrtShortBlank },
	/*::[*/0x000D/*::]*/: { n:"BrtShortRk", f:parse_BrtShortRk },
	/*::[*/0x000E/*::]*/: { n:"BrtShortError", f:parse_BrtShortError },
	/*::[*/0x000F/*::]*/: { n:"BrtShortBool", f:parse_BrtShortBool },
	/*::[*/0x0010/*::]*/: { n:"BrtShortReal", f:parse_BrtShortReal },
	/*::[*/0x0011/*::]*/: { n:"BrtShortSt", f:parse_BrtShortSt },
	/*::[*/0x0012/*::]*/: { n:"BrtShortIsst", f:parse_BrtShortIsst },
	/*::[*/0x0013/*::]*/: { n:"BrtSSTItem", f:parse_RichStr },
	/*::[*/0x0014/*::]*/: { n:"BrtPCDIMissing" },
	/*::[*/0x0015/*::]*/: { n:"BrtPCDINumber" },
	/*::[*/0x0016/*::]*/: { n:"BrtPCDIBoolean" },
	/*::[*/0x0017/*::]*/: { n:"BrtPCDIError" },
	/*::[*/0x0018/*::]*/: { n:"BrtPCDIString" },
	/*::[*/0x0019/*::]*/: { n:"BrtPCDIDatetime" },
	/*::[*/0x001A/*::]*/: { n:"BrtPCDIIndex" },
	/*::[*/0x001B/*::]*/: { n:"BrtPCDIAMissing" },
	/*::[*/0x001C/*::]*/: { n:"BrtPCDIANumber" },
	/*::[*/0x001D/*::]*/: { n:"BrtPCDIABoolean" },
	/*::[*/0x001E/*::]*/: { n:"BrtPCDIAError" },
	/*::[*/0x001F/*::]*/: { n:"BrtPCDIAString" },
	/*::[*/0x0020/*::]*/: { n:"BrtPCDIADatetime" },
	/*::[*/0x0021/*::]*/: { n:"BrtPCRRecord" },
	/*::[*/0x0022/*::]*/: { n:"BrtPCRRecordDt" },
	/*::[*/0x0023/*::]*/: { n:"BrtFRTBegin" },
	/*::[*/0x0024/*::]*/: { n:"BrtFRTEnd" },
	/*::[*/0x0025/*::]*/: { n:"BrtACBegin" },
	/*::[*/0x0026/*::]*/: { n:"BrtACEnd" },
	/*::[*/0x0027/*::]*/: { n:"BrtName", f:parse_BrtName },
	/*::[*/0x0028/*::]*/: { n:"BrtIndexRowBlock" },
	/*::[*/0x002A/*::]*/: { n:"BrtIndexBlock" },
	/*::[*/0x002B/*::]*/: { n:"BrtFont", f:parse_BrtFont },
	/*::[*/0x002C/*::]*/: { n:"BrtFmt", f:parse_BrtFmt },
	/*::[*/0x002D/*::]*/: { n:"BrtFill", f:parse_BrtFill },
	/*::[*/0x002E/*::]*/: { n:"BrtBorder", f:parse_BrtBorder },
	/*::[*/0x002F/*::]*/: { n:"BrtXF", f:parse_BrtXF },
	/*::[*/0x0030/*::]*/: { n:"BrtStyle" },
	/*::[*/0x0031/*::]*/: { n:"BrtCellMeta" },
	/*::[*/0x0032/*::]*/: { n:"BrtValueMeta" },
	/*::[*/0x0033/*::]*/: { n:"BrtMdb" },
	/*::[*/0x0034/*::]*/: { n:"BrtBeginFmd" },
	/*::[*/0x0035/*::]*/: { n:"BrtEndFmd" },
	/*::[*/0x0036/*::]*/: { n:"BrtBeginMdx" },
	/*::[*/0x0037/*::]*/: { n:"BrtEndMdx" },
	/*::[*/0x0038/*::]*/: { n:"BrtBeginMdxTuple" },
	/*::[*/0x0039/*::]*/: { n:"BrtEndMdxTuple" },
	/*::[*/0x003A/*::]*/: { n:"BrtMdxMbrIstr" },
	/*::[*/0x003B/*::]*/: { n:"BrtStr" },
	/*::[*/0x003C/*::]*/: { n:"BrtColInfo", f:parse_ColInfo },
	/*::[*/0x003E/*::]*/: { n:"BrtCellRString" },
	/*::[*/0x003F/*::]*/: { n:"BrtCalcChainItem$", f:parse_BrtCalcChainItem$ },
	/*::[*/0x0040/*::]*/: { n:"BrtDVal", f:parse_BrtDVal },
	/*::[*/0x0041/*::]*/: { n:"BrtSxvcellNum" },
	/*::[*/0x0042/*::]*/: { n:"BrtSxvcellStr" },
	/*::[*/0x0043/*::]*/: { n:"BrtSxvcellBool" },
	/*::[*/0x0044/*::]*/: { n:"BrtSxvcellErr" },
	/*::[*/0x0045/*::]*/: { n:"BrtSxvcellDate" },
	/*::[*/0x0046/*::]*/: { n:"BrtSxvcellNil" },
	/*::[*/0x0080/*::]*/: { n:"BrtFileVersion" },
	/*::[*/0x0081/*::]*/: { n:"BrtBeginSheet" },
	/*::[*/0x0082/*::]*/: { n:"BrtEndSheet" },
	/*::[*/0x0083/*::]*/: { n:"BrtBeginBook", f:parsenoop, p:0 },
	/*::[*/0x0084/*::]*/: { n:"BrtEndBook" },
	/*::[*/0x0085/*::]*/: { n:"BrtBeginWsViews" },
	/*::[*/0x0086/*::]*/: { n:"BrtEndWsViews" },
	/*::[*/0x0087/*::]*/: { n:"BrtBeginBookViews" },
	/*::[*/0x0088/*::]*/: { n:"BrtEndBookViews" },
	/*::[*/0x0089/*::]*/: { n:"BrtBeginWsView", f:parse_BrtBeginWsView },
	/*::[*/0x008A/*::]*/: { n:"BrtEndWsView" },
	/*::[*/0x008B/*::]*/: { n:"BrtBeginCsViews" },
	/*::[*/0x008C/*::]*/: { n:"BrtEndCsViews" },
	/*::[*/0x008D/*::]*/: { n:"BrtBeginCsView" },
	/*::[*/0x008E/*::]*/: { n:"BrtEndCsView" },
	/*::[*/0x008F/*::]*/: { n:"BrtBeginBundleShs" },
	/*::[*/0x0090/*::]*/: { n:"BrtEndBundleShs" },
	/*::[*/0x0091/*::]*/: { n:"BrtBeginSheetData" },
	/*::[*/0x0092/*::]*/: { n:"BrtEndSheetData" },
	/*::[*/0x0093/*::]*/: { n:"BrtWsProp", f:parse_BrtWsProp },
	/*::[*/0x0094/*::]*/: { n:"BrtWsDim", f:parse_BrtWsDim, p:16 },
	/*::[*/0x0097/*::]*/: { n:"BrtPane", f:parse_BrtPane },
	/*::[*/0x0098/*::]*/: { n:"BrtSel" },
	/*::[*/0x0099/*::]*/: { n:"BrtWbProp", f:parse_BrtWbProp },
	/*::[*/0x009A/*::]*/: { n:"BrtWbFactoid" },
	/*::[*/0x009B/*::]*/: { n:"BrtFileRecover" },
	/*::[*/0x009C/*::]*/: { n:"BrtBundleSh", f:parse_BrtBundleSh },
	/*::[*/0x009D/*::]*/: { n:"BrtCalcProp" },
	/*::[*/0x009E/*::]*/: { n:"BrtBookView" },
	/*::[*/0x009F/*::]*/: { n:"BrtBeginSst", f:parse_BrtBeginSst },
	/*::[*/0x00A0/*::]*/: { n:"BrtEndSst" },
	/*::[*/0x00A1/*::]*/: { n:"BrtBeginAFilter", f:parse_UncheckedRfX },
	/*::[*/0x00A2/*::]*/: { n:"BrtEndAFilter" },
	/*::[*/0x00A3/*::]*/: { n:"BrtBeginFilterColumn" },
	/*::[*/0x00A4/*::]*/: { n:"BrtEndFilterColumn" },
	/*::[*/0x00A5/*::]*/: { n:"BrtBeginFilters" },
	/*::[*/0x00A6/*::]*/: { n:"BrtEndFilters" },
	/*::[*/0x00A7/*::]*/: { n:"BrtFilter" },
	/*::[*/0x00A8/*::]*/: { n:"BrtColorFilter" },
	/*::[*/0x00A9/*::]*/: { n:"BrtIconFilter" },
	/*::[*/0x00AA/*::]*/: { n:"BrtTop10Filter" },
	/*::[*/0x00AB/*::]*/: { n:"BrtDynamicFilter" },
	/*::[*/0x00AC/*::]*/: { n:"BrtBeginCustomFilters" },
	/*::[*/0x00AD/*::]*/: { n:"BrtEndCustomFilters" },
	/*::[*/0x00AE/*::]*/: { n:"BrtCustomFilter" },
	/*::[*/0x00AF/*::]*/: { n:"BrtAFilterDateGroupItem" },
	/*::[*/0x00B0/*::]*/: { n:"BrtMergeCell", f:parse_BrtMergeCell },
	/*::[*/0x00B1/*::]*/: { n:"BrtBeginMergeCells" },
	/*::[*/0x00B2/*::]*/: { n:"BrtEndMergeCells" },
	/*::[*/0x00B3/*::]*/: { n:"BrtBeginPivotCacheDef" },
	/*::[*/0x00B4/*::]*/: { n:"BrtEndPivotCacheDef" },
	/*::[*/0x00B5/*::]*/: { n:"BrtBeginPCDFields" },
	/*::[*/0x00B6/*::]*/: { n:"BrtEndPCDFields" },
	/*::[*/0x00B7/*::]*/: { n:"BrtBeginPCDField" },
	/*::[*/0x00B8/*::]*/: { n:"BrtEndPCDField" },
	/*::[*/0x00B9/*::]*/: { n:"BrtBeginPCDSource" },
	/*::[*/0x00BA/*::]*/: { n:"BrtEndPCDSource" },
	/*::[*/0x00BB/*::]*/: { n:"BrtBeginPCDSRange" },
	/*::[*/0x00BC/*::]*/: { n:"BrtEndPCDSRange" },
	/*::[*/0x00BD/*::]*/: { n:"BrtBeginPCDFAtbl" },
	/*::[*/0x00BE/*::]*/: { n:"BrtEndPCDFAtbl" },
	/*::[*/0x00BF/*::]*/: { n:"BrtBeginPCDIRun" },
	/*::[*/0x00C0/*::]*/: { n:"BrtEndPCDIRun" },
	/*::[*/0x00C1/*::]*/: { n:"BrtBeginPivotCacheRecords" },
	/*::[*/0x00C2/*::]*/: { n:"BrtEndPivotCacheRecords" },
	/*::[*/0x00C3/*::]*/: { n:"BrtBeginPCDHierarchies" },
	/*::[*/0x00C4/*::]*/: { n:"BrtEndPCDHierarchies" },
	/*::[*/0x00C5/*::]*/: { n:"BrtBeginPCDHierarchy" },
	/*::[*/0x00C6/*::]*/: { n:"BrtEndPCDHierarchy" },
	/*::[*/0x00C7/*::]*/: { n:"BrtBeginPCDHFieldsUsage" },
	/*::[*/0x00C8/*::]*/: { n:"BrtEndPCDHFieldsUsage" },
	/*::[*/0x00C9/*::]*/: { n:"BrtBeginExtConnection" },
	/*::[*/0x00CA/*::]*/: { n:"BrtEndExtConnection" },
	/*::[*/0x00CB/*::]*/: { n:"BrtBeginECDbProps" },
	/*::[*/0x00CC/*::]*/: { n:"BrtEndECDbProps" },
	/*::[*/0x00CD/*::]*/: { n:"BrtBeginECOlapProps" },
	/*::[*/0x00CE/*::]*/: { n:"BrtEndECOlapProps" },
	/*::[*/0x00CF/*::]*/: { n:"BrtBeginPCDSConsol" },
	/*::[*/0x00D0/*::]*/: { n:"BrtEndPCDSConsol" },
	/*::[*/0x00D1/*::]*/: { n:"BrtBeginPCDSCPages" },
	/*::[*/0x00D2/*::]*/: { n:"BrtEndPCDSCPages" },
	/*::[*/0x00D3/*::]*/: { n:"BrtBeginPCDSCPage" },
	/*::[*/0x00D4/*::]*/: { n:"BrtEndPCDSCPage" },
	/*::[*/0x00D5/*::]*/: { n:"BrtBeginPCDSCPItem" },
	/*::[*/0x00D6/*::]*/: { n:"BrtEndPCDSCPItem" },
	/*::[*/0x00D7/*::]*/: { n:"BrtBeginPCDSCSets" },
	/*::[*/0x00D8/*::]*/: { n:"BrtEndPCDSCSets" },
	/*::[*/0x00D9/*::]*/: { n:"BrtBeginPCDSCSet" },
	/*::[*/0x00DA/*::]*/: { n:"BrtEndPCDSCSet" },
	/*::[*/0x00DB/*::]*/: { n:"BrtBeginPCDFGroup" },
	/*::[*/0x00DC/*::]*/: { n:"BrtEndPCDFGroup" },
	/*::[*/0x00DD/*::]*/: { n:"BrtBeginPCDFGItems" },
	/*::[*/0x00DE/*::]*/: { n:"BrtEndPCDFGItems" },
	/*::[*/0x00DF/*::]*/: { n:"BrtBeginPCDFGRange" },
	/*::[*/0x00E0/*::]*/: { n:"BrtEndPCDFGRange" },
	/*::[*/0x00E1/*::]*/: { n:"BrtBeginPCDFGDiscrete" },
	/*::[*/0x00E2/*::]*/: { n:"BrtEndPCDFGDiscrete" },
	/*::[*/0x00E3/*::]*/: { n:"BrtBeginPCDSDTupleCache" },
	/*::[*/0x00E4/*::]*/: { n:"BrtEndPCDSDTupleCache" },
	/*::[*/0x00E5/*::]*/: { n:"BrtBeginPCDSDTCEntries" },
	/*::[*/0x00E6/*::]*/: { n:"BrtEndPCDSDTCEntries" },
	/*::[*/0x00E7/*::]*/: { n:"BrtBeginPCDSDTCEMembers" },
	/*::[*/0x00E8/*::]*/: { n:"BrtEndPCDSDTCEMembers" },
	/*::[*/0x00E9/*::]*/: { n:"BrtBeginPCDSDTCEMember" },
	/*::[*/0x00EA/*::]*/: { n:"BrtEndPCDSDTCEMember" },
	/*::[*/0x00EB/*::]*/: { n:"BrtBeginPCDSDTCQueries" },
	/*::[*/0x00EC/*::]*/: { n:"BrtEndPCDSDTCQueries" },
	/*::[*/0x00ED/*::]*/: { n:"BrtBeginPCDSDTCQuery" },
	/*::[*/0x00EE/*::]*/: { n:"BrtEndPCDSDTCQuery" },
	/*::[*/0x00EF/*::]*/: { n:"BrtBeginPCDSDTCSets" },
	/*::[*/0x00F0/*::]*/: { n:"BrtEndPCDSDTCSets" },
	/*::[*/0x00F1/*::]*/: { n:"BrtBeginPCDSDTCSet" },
	/*::[*/0x00F2/*::]*/: { n:"BrtEndPCDSDTCSet" },
	/*::[*/0x00F3/*::]*/: { n:"BrtBeginPCDCalcItems" },
	/*::[*/0x00F4/*::]*/: { n:"BrtEndPCDCalcItems" },
	/*::[*/0x00F5/*::]*/: { n:"BrtBeginPCDCalcItem" },
	/*::[*/0x00F6/*::]*/: { n:"BrtEndPCDCalcItem" },
	/*::[*/0x00F7/*::]*/: { n:"BrtBeginPRule" },
	/*::[*/0x00F8/*::]*/: { n:"BrtEndPRule" },
	/*::[*/0x00F9/*::]*/: { n:"BrtBeginPRFilters" },
	/*::[*/0x00FA/*::]*/: { n:"BrtEndPRFilters" },
	/*::[*/0x00FB/*::]*/: { n:"BrtBeginPRFilter" },
	/*::[*/0x00FC/*::]*/: { n:"BrtEndPRFilter" },
	/*::[*/0x00FD/*::]*/: { n:"BrtBeginPNames" },
	/*::[*/0x00FE/*::]*/: { n:"BrtEndPNames" },
	/*::[*/0x00FF/*::]*/: { n:"BrtBeginPName" },
	/*::[*/0x0100/*::]*/: { n:"BrtEndPName" },
	/*::[*/0x0101/*::]*/: { n:"BrtBeginPNPairs" },
	/*::[*/0x0102/*::]*/: { n:"BrtEndPNPairs" },
	/*::[*/0x0103/*::]*/: { n:"BrtBeginPNPair" },
	/*::[*/0x0104/*::]*/: { n:"BrtEndPNPair" },
	/*::[*/0x0105/*::]*/: { n:"BrtBeginECWebProps" },
	/*::[*/0x0106/*::]*/: { n:"BrtEndECWebProps" },
	/*::[*/0x0107/*::]*/: { n:"BrtBeginEcWpTables" },
	/*::[*/0x0108/*::]*/: { n:"BrtEndECWPTables" },
	/*::[*/0x0109/*::]*/: { n:"BrtBeginECParams" },
	/*::[*/0x010A/*::]*/: { n:"BrtEndECParams" },
	/*::[*/0x010B/*::]*/: { n:"BrtBeginECParam" },
	/*::[*/0x010C/*::]*/: { n:"BrtEndECParam" },
	/*::[*/0x010D/*::]*/: { n:"BrtBeginPCDKPIs" },
	/*::[*/0x010E/*::]*/: { n:"BrtEndPCDKPIs" },
	/*::[*/0x010F/*::]*/: { n:"BrtBeginPCDKPI" },
	/*::[*/0x0110/*::]*/: { n:"BrtEndPCDKPI" },
	/*::[*/0x0111/*::]*/: { n:"BrtBeginDims" },
	/*::[*/0x0112/*::]*/: { n:"BrtEndDims" },
	/*::[*/0x0113/*::]*/: { n:"BrtBeginDim" },
	/*::[*/0x0114/*::]*/: { n:"BrtEndDim" },
	/*::[*/0x0115/*::]*/: { n:"BrtIndexPartEnd" },
	/*::[*/0x0116/*::]*/: { n:"BrtBeginStyleSheet" },
	/*::[*/0x0117/*::]*/: { n:"BrtEndStyleSheet" },
	/*::[*/0x0118/*::]*/: { n:"BrtBeginSXView" },
	/*::[*/0x0119/*::]*/: { n:"BrtEndSXVI" },
	/*::[*/0x011A/*::]*/: { n:"BrtBeginSXVI" },
	/*::[*/0x011B/*::]*/: { n:"BrtBeginSXVIs" },
	/*::[*/0x011C/*::]*/: { n:"BrtEndSXVIs" },
	/*::[*/0x011D/*::]*/: { n:"BrtBeginSXVD" },
	/*::[*/0x011E/*::]*/: { n:"BrtEndSXVD" },
	/*::[*/0x011F/*::]*/: { n:"BrtBeginSXVDs" },
	/*::[*/0x0120/*::]*/: { n:"BrtEndSXVDs" },
	/*::[*/0x0121/*::]*/: { n:"BrtBeginSXPI" },
	/*::[*/0x0122/*::]*/: { n:"BrtEndSXPI" },
	/*::[*/0x0123/*::]*/: { n:"BrtBeginSXPIs" },
	/*::[*/0x0124/*::]*/: { n:"BrtEndSXPIs" },
	/*::[*/0x0125/*::]*/: { n:"BrtBeginSXDI" },
	/*::[*/0x0126/*::]*/: { n:"BrtEndSXDI" },
	/*::[*/0x0127/*::]*/: { n:"BrtBeginSXDIs" },
	/*::[*/0x0128/*::]*/: { n:"BrtEndSXDIs" },
	/*::[*/0x0129/*::]*/: { n:"BrtBeginSXLI" },
	/*::[*/0x012A/*::]*/: { n:"BrtEndSXLI" },
	/*::[*/0x012B/*::]*/: { n:"BrtBeginSXLIRws" },
	/*::[*/0x012C/*::]*/: { n:"BrtEndSXLIRws" },
	/*::[*/0x012D/*::]*/: { n:"BrtBeginSXLICols" },
	/*::[*/0x012E/*::]*/: { n:"BrtEndSXLICols" },
	/*::[*/0x012F/*::]*/: { n:"BrtBeginSXFormat" },
	/*::[*/0x0130/*::]*/: { n:"BrtEndSXFormat" },
	/*::[*/0x0131/*::]*/: { n:"BrtBeginSXFormats" },
	/*::[*/0x0132/*::]*/: { n:"BrtEndSxFormats" },
	/*::[*/0x0133/*::]*/: { n:"BrtBeginSxSelect" },
	/*::[*/0x0134/*::]*/: { n:"BrtEndSxSelect" },
	/*::[*/0x0135/*::]*/: { n:"BrtBeginISXVDRws" },
	/*::[*/0x0136/*::]*/: { n:"BrtEndISXVDRws" },
	/*::[*/0x0137/*::]*/: { n:"BrtBeginISXVDCols" },
	/*::[*/0x0138/*::]*/: { n:"BrtEndISXVDCols" },
	/*::[*/0x0139/*::]*/: { n:"BrtEndSXLocation" },
	/*::[*/0x013A/*::]*/: { n:"BrtBeginSXLocation" },
	/*::[*/0x013B/*::]*/: { n:"BrtEndSXView" },
	/*::[*/0x013C/*::]*/: { n:"BrtBeginSXTHs" },
	/*::[*/0x013D/*::]*/: { n:"BrtEndSXTHs" },
	/*::[*/0x013E/*::]*/: { n:"BrtBeginSXTH" },
	/*::[*/0x013F/*::]*/: { n:"BrtEndSXTH" },
	/*::[*/0x0140/*::]*/: { n:"BrtBeginISXTHRws" },
	/*::[*/0x0141/*::]*/: { n:"BrtEndISXTHRws" },
	/*::[*/0x0142/*::]*/: { n:"BrtBeginISXTHCols" },
	/*::[*/0x0143/*::]*/: { n:"BrtEndISXTHCols" },
	/*::[*/0x0144/*::]*/: { n:"BrtBeginSXTDMPS" },
	/*::[*/0x0145/*::]*/: { n:"BrtEndSXTDMPs" },
	/*::[*/0x0146/*::]*/: { n:"BrtBeginSXTDMP" },
	/*::[*/0x0147/*::]*/: { n:"BrtEndSXTDMP" },
	/*::[*/0x0148/*::]*/: { n:"BrtBeginSXTHItems" },
	/*::[*/0x0149/*::]*/: { n:"BrtEndSXTHItems" },
	/*::[*/0x014A/*::]*/: { n:"BrtBeginSXTHItem" },
	/*::[*/0x014B/*::]*/: { n:"BrtEndSXTHItem" },
	/*::[*/0x014C/*::]*/: { n:"BrtBeginMetadata" },
	/*::[*/0x014D/*::]*/: { n:"BrtEndMetadata" },
	/*::[*/0x014E/*::]*/: { n:"BrtBeginEsmdtinfo" },
	/*::[*/0x014F/*::]*/: { n:"BrtMdtinfo" },
	/*::[*/0x0150/*::]*/: { n:"BrtEndEsmdtinfo" },
	/*::[*/0x0151/*::]*/: { n:"BrtBeginEsmdb" },
	/*::[*/0x0152/*::]*/: { n:"BrtEndEsmdb" },
	/*::[*/0x0153/*::]*/: { n:"BrtBeginEsfmd" },
	/*::[*/0x0154/*::]*/: { n:"BrtEndEsfmd" },
	/*::[*/0x0155/*::]*/: { n:"BrtBeginSingleCells" },
	/*::[*/0x0156/*::]*/: { n:"BrtEndSingleCells" },
	/*::[*/0x0157/*::]*/: { n:"BrtBeginList" },
	/*::[*/0x0158/*::]*/: { n:"BrtEndList" },
	/*::[*/0x0159/*::]*/: { n:"BrtBeginListCols" },
	/*::[*/0x015A/*::]*/: { n:"BrtEndListCols" },
	/*::[*/0x015B/*::]*/: { n:"BrtBeginListCol" },
	/*::[*/0x015C/*::]*/: { n:"BrtEndListCol" },
	/*::[*/0x015D/*::]*/: { n:"BrtBeginListXmlCPr" },
	/*::[*/0x015E/*::]*/: { n:"BrtEndListXmlCPr" },
	/*::[*/0x015F/*::]*/: { n:"BrtListCCFmla" },
	/*::[*/0x0160/*::]*/: { n:"BrtListTrFmla" },
	/*::[*/0x0161/*::]*/: { n:"BrtBeginExternals" },
	/*::[*/0x0162/*::]*/: { n:"BrtEndExternals" },
	/*::[*/0x0163/*::]*/: { n:"BrtSupBookSrc", f:parse_RelID},
	/*::[*/0x0165/*::]*/: { n:"BrtSupSelf" },
	/*::[*/0x0166/*::]*/: { n:"BrtSupSame" },
	/*::[*/0x0167/*::]*/: { n:"BrtSupTabs" },
	/*::[*/0x0168/*::]*/: { n:"BrtBeginSupBook" },
	/*::[*/0x0169/*::]*/: { n:"BrtPlaceholderName" },
	/*::[*/0x016A/*::]*/: { n:"BrtExternSheet", f:parse_ExternSheet },
	/*::[*/0x016B/*::]*/: { n:"BrtExternTableStart" },
	/*::[*/0x016C/*::]*/: { n:"BrtExternTableEnd" },
	/*::[*/0x016E/*::]*/: { n:"BrtExternRowHdr" },
	/*::[*/0x016F/*::]*/: { n:"BrtExternCellBlank" },
	/*::[*/0x0170/*::]*/: { n:"BrtExternCellReal" },
	/*::[*/0x0171/*::]*/: { n:"BrtExternCellBool" },
	/*::[*/0x0172/*::]*/: { n:"BrtExternCellError" },
	/*::[*/0x0173/*::]*/: { n:"BrtExternCellString" },
	/*::[*/0x0174/*::]*/: { n:"BrtBeginEsmdx" },
	/*::[*/0x0175/*::]*/: { n:"BrtEndEsmdx" },
	/*::[*/0x0176/*::]*/: { n:"BrtBeginMdxSet" },
	/*::[*/0x0177/*::]*/: { n:"BrtEndMdxSet" },
	/*::[*/0x0178/*::]*/: { n:"BrtBeginMdxMbrProp" },
	/*::[*/0x0179/*::]*/: { n:"BrtEndMdxMbrProp" },
	/*::[*/0x017A/*::]*/: { n:"BrtBeginMdxKPI" },
	/*::[*/0x017B/*::]*/: { n:"BrtEndMdxKPI" },
	/*::[*/0x017C/*::]*/: { n:"BrtBeginEsstr" },
	/*::[*/0x017D/*::]*/: { n:"BrtEndEsstr" },
	/*::[*/0x017E/*::]*/: { n:"BrtBeginPRFItem" },
	/*::[*/0x017F/*::]*/: { n:"BrtEndPRFItem" },
	/*::[*/0x0180/*::]*/: { n:"BrtBeginPivotCacheIDs" },
	/*::[*/0x0181/*::]*/: { n:"BrtEndPivotCacheIDs" },
	/*::[*/0x0182/*::]*/: { n:"BrtBeginPivotCacheID" },
	/*::[*/0x0183/*::]*/: { n:"BrtEndPivotCacheID" },
	/*::[*/0x0184/*::]*/: { n:"BrtBeginISXVIs" },
	/*::[*/0x0185/*::]*/: { n:"BrtEndISXVIs" },
	/*::[*/0x0186/*::]*/: { n:"BrtBeginColInfos" },
	/*::[*/0x0187/*::]*/: { n:"BrtEndColInfos" },
	/*::[*/0x0188/*::]*/: { n:"BrtBeginRwBrk" },
	/*::[*/0x0189/*::]*/: { n:"BrtEndRwBrk" },
	/*::[*/0x018A/*::]*/: { n:"BrtBeginColBrk" },
	/*::[*/0x018B/*::]*/: { n:"BrtEndColBrk" },
	/*::[*/0x018C/*::]*/: { n:"BrtBrk" },
	/*::[*/0x018D/*::]*/: { n:"BrtUserBookView" },
	/*::[*/0x018E/*::]*/: { n:"BrtInfo" },
	/*::[*/0x018F/*::]*/: { n:"BrtCUsr" },
	/*::[*/0x0190/*::]*/: { n:"BrtUsr" },
	/*::[*/0x0191/*::]*/: { n:"BrtBeginUsers" },
	/*::[*/0x0193/*::]*/: { n:"BrtEOF" },
	/*::[*/0x0194/*::]*/: { n:"BrtUCR" },
	/*::[*/0x0195/*::]*/: { n:"BrtRRInsDel" },
	/*::[*/0x0196/*::]*/: { n:"BrtRREndInsDel" },
	/*::[*/0x0197/*::]*/: { n:"BrtRRMove" },
	/*::[*/0x0198/*::]*/: { n:"BrtRREndMove" },
	/*::[*/0x0199/*::]*/: { n:"BrtRRChgCell" },
	/*::[*/0x019A/*::]*/: { n:"BrtRREndChgCell" },
	/*::[*/0x019B/*::]*/: { n:"BrtRRHeader" },
	/*::[*/0x019C/*::]*/: { n:"BrtRRUserView" },
	/*::[*/0x019D/*::]*/: { n:"BrtRRRenSheet" },
	/*::[*/0x019E/*::]*/: { n:"BrtRRInsertSh" },
	/*::[*/0x019F/*::]*/: { n:"BrtRRDefName" },
	/*::[*/0x01A0/*::]*/: { n:"BrtRRNote" },
	/*::[*/0x01A1/*::]*/: { n:"BrtRRConflict" },
	/*::[*/0x01A2/*::]*/: { n:"BrtRRTQSIF" },
	/*::[*/0x01A3/*::]*/: { n:"BrtRRFormat" },
	/*::[*/0x01A4/*::]*/: { n:"BrtRREndFormat" },
	/*::[*/0x01A5/*::]*/: { n:"BrtRRAutoFmt" },
	/*::[*/0x01A6/*::]*/: { n:"BrtBeginUserShViews" },
	/*::[*/0x01A7/*::]*/: { n:"BrtBeginUserShView" },
	/*::[*/0x01A8/*::]*/: { n:"BrtEndUserShView" },
	/*::[*/0x01A9/*::]*/: { n:"BrtEndUserShViews" },
	/*::[*/0x01AA/*::]*/: { n:"BrtArrFmla", f:parse_BrtArrFmla },
	/*::[*/0x01AB/*::]*/: { n:"BrtShrFmla", f:parse_BrtShrFmla },
	/*::[*/0x01AC/*::]*/: { n:"BrtTable" },
	/*::[*/0x01AD/*::]*/: { n:"BrtBeginExtConnections" },
	/*::[*/0x01AE/*::]*/: { n:"BrtEndExtConnections" },
	/*::[*/0x01AF/*::]*/: { n:"BrtBeginPCDCalcMems" },
	/*::[*/0x01B0/*::]*/: { n:"BrtEndPCDCalcMems" },
	/*::[*/0x01B1/*::]*/: { n:"BrtBeginPCDCalcMem" },
	/*::[*/0x01B2/*::]*/: { n:"BrtEndPCDCalcMem" },
	/*::[*/0x01B3/*::]*/: { n:"BrtBeginPCDHGLevels" },
	/*::[*/0x01B4/*::]*/: { n:"BrtEndPCDHGLevels" },
	/*::[*/0x01B5/*::]*/: { n:"BrtBeginPCDHGLevel" },
	/*::[*/0x01B6/*::]*/: { n:"BrtEndPCDHGLevel" },
	/*::[*/0x01B7/*::]*/: { n:"BrtBeginPCDHGLGroups" },
	/*::[*/0x01B8/*::]*/: { n:"BrtEndPCDHGLGroups" },
	/*::[*/0x01B9/*::]*/: { n:"BrtBeginPCDHGLGroup" },
	/*::[*/0x01BA/*::]*/: { n:"BrtEndPCDHGLGroup" },
	/*::[*/0x01BB/*::]*/: { n:"BrtBeginPCDHGLGMembers" },
	/*::[*/0x01BC/*::]*/: { n:"BrtEndPCDHGLGMembers" },
	/*::[*/0x01BD/*::]*/: { n:"BrtBeginPCDHGLGMember" },
	/*::[*/0x01BE/*::]*/: { n:"BrtEndPCDHGLGMember" },
	/*::[*/0x01BF/*::]*/: { n:"BrtBeginQSI" },
	/*::[*/0x01C0/*::]*/: { n:"BrtEndQSI" },
	/*::[*/0x01C1/*::]*/: { n:"BrtBeginQSIR" },
	/*::[*/0x01C2/*::]*/: { n:"BrtEndQSIR" },
	/*::[*/0x01C3/*::]*/: { n:"BrtBeginDeletedNames" },
	/*::[*/0x01C4/*::]*/: { n:"BrtEndDeletedNames" },
	/*::[*/0x01C5/*::]*/: { n:"BrtBeginDeletedName" },
	/*::[*/0x01C6/*::]*/: { n:"BrtEndDeletedName" },
	/*::[*/0x01C7/*::]*/: { n:"BrtBeginQSIFs" },
	/*::[*/0x01C8/*::]*/: { n:"BrtEndQSIFs" },
	/*::[*/0x01C9/*::]*/: { n:"BrtBeginQSIF" },
	/*::[*/0x01CA/*::]*/: { n:"BrtEndQSIF" },
	/*::[*/0x01CB/*::]*/: { n:"BrtBeginAutoSortScope" },
	/*::[*/0x01CC/*::]*/: { n:"BrtEndAutoSortScope" },
	/*::[*/0x01CD/*::]*/: { n:"BrtBeginConditionalFormatting" },
	/*::[*/0x01CE/*::]*/: { n:"BrtEndConditionalFormatting" },
	/*::[*/0x01CF/*::]*/: { n:"BrtBeginCFRule" },
	/*::[*/0x01D0/*::]*/: { n:"BrtEndCFRule" },
	/*::[*/0x01D1/*::]*/: { n:"BrtBeginIconSet" },
	/*::[*/0x01D2/*::]*/: { n:"BrtEndIconSet" },
	/*::[*/0x01D3/*::]*/: { n:"BrtBeginDatabar" },
	/*::[*/0x01D4/*::]*/: { n:"BrtEndDatabar" },
	/*::[*/0x01D5/*::]*/: { n:"BrtBeginColorScale" },
	/*::[*/0x01D6/*::]*/: { n:"BrtEndColorScale" },
	/*::[*/0x01D7/*::]*/: { n:"BrtCFVO" },
	/*::[*/0x01D8/*::]*/: { n:"BrtExternValueMeta" },
	/*::[*/0x01D9/*::]*/: { n:"BrtBeginColorPalette" },
	/*::[*/0x01DA/*::]*/: { n:"BrtEndColorPalette" },
	/*::[*/0x01DB/*::]*/: { n:"BrtIndexedColor" },
	/*::[*/0x01DC/*::]*/: { n:"BrtMargins", f:parse_BrtMargins },
	/*::[*/0x01DD/*::]*/: { n:"BrtPrintOptions" },
	/*::[*/0x01DE/*::]*/: { n:"BrtPageSetup" },
	/*::[*/0x01DF/*::]*/: { n:"BrtBeginHeaderFooter" },
	/*::[*/0x01E0/*::]*/: { n:"BrtEndHeaderFooter" },
	/*::[*/0x01E1/*::]*/: { n:"BrtBeginSXCrtFormat" },
	/*::[*/0x01E2/*::]*/: { n:"BrtEndSXCrtFormat" },
	/*::[*/0x01E3/*::]*/: { n:"BrtBeginSXCrtFormats" },
	/*::[*/0x01E4/*::]*/: { n:"BrtEndSXCrtFormats" },
	/*::[*/0x01E5/*::]*/: { n:"BrtWsFmtInfo", f:parse_BrtWsFmtInfo },
	/*::[*/0x01E6/*::]*/: { n:"BrtBeginMgs" },
	/*::[*/0x01E7/*::]*/: { n:"BrtEndMGs" },
	/*::[*/0x01E8/*::]*/: { n:"BrtBeginMGMaps" },
	/*::[*/0x01E9/*::]*/: { n:"BrtEndMGMaps" },
	/*::[*/0x01EA/*::]*/: { n:"BrtBeginMG" },
	/*::[*/0x01EB/*::]*/: { n:"BrtEndMG" },
	/*::[*/0x01EC/*::]*/: { n:"BrtBeginMap" },
	/*::[*/0x01ED/*::]*/: { n:"BrtEndMap" },
	/*::[*/0x01EE/*::]*/: { n:"BrtHLink", f:parse_BrtHLink },
	/*::[*/0x01EF/*::]*/: { n:"BrtBeginDCon" },
	/*::[*/0x01F0/*::]*/: { n:"BrtEndDCon" },
	/*::[*/0x01F1/*::]*/: { n:"BrtBeginDRefs" },
	/*::[*/0x01F2/*::]*/: { n:"BrtEndDRefs" },
	/*::[*/0x01F3/*::]*/: { n:"BrtDRef" },
	/*::[*/0x01F4/*::]*/: { n:"BrtBeginScenMan" },
	/*::[*/0x01F5/*::]*/: { n:"BrtEndScenMan" },
	/*::[*/0x01F6/*::]*/: { n:"BrtBeginSct" },
	/*::[*/0x01F7/*::]*/: { n:"BrtEndSct" },
	/*::[*/0x01F8/*::]*/: { n:"BrtSlc" },
	/*::[*/0x01F9/*::]*/: { n:"BrtBeginDXFs" },
	/*::[*/0x01FA/*::]*/: { n:"BrtEndDXFs" },
	/*::[*/0x01FB/*::]*/: { n:"BrtDXF" },
	/*::[*/0x01FC/*::]*/: { n:"BrtBeginTableStyles" },
	/*::[*/0x01FD/*::]*/: { n:"BrtEndTableStyles" },
	/*::[*/0x01FE/*::]*/: { n:"BrtBeginTableStyle" },
	/*::[*/0x01FF/*::]*/: { n:"BrtEndTableStyle" },
	/*::[*/0x0200/*::]*/: { n:"BrtTableStyleElement" },
	/*::[*/0x0201/*::]*/: { n:"BrtTableStyleClient" },
	/*::[*/0x0202/*::]*/: { n:"BrtBeginVolDeps" },
	/*::[*/0x0203/*::]*/: { n:"BrtEndVolDeps" },
	/*::[*/0x0204/*::]*/: { n:"BrtBeginVolType" },
	/*::[*/0x0205/*::]*/: { n:"BrtEndVolType" },
	/*::[*/0x0206/*::]*/: { n:"BrtBeginVolMain" },
	/*::[*/0x0207/*::]*/: { n:"BrtEndVolMain" },
	/*::[*/0x0208/*::]*/: { n:"BrtBeginVolTopic" },
	/*::[*/0x0209/*::]*/: { n:"BrtEndVolTopic" },
	/*::[*/0x020A/*::]*/: { n:"BrtVolSubtopic" },
	/*::[*/0x020B/*::]*/: { n:"BrtVolRef" },
	/*::[*/0x020C/*::]*/: { n:"BrtVolNum" },
	/*::[*/0x020D/*::]*/: { n:"BrtVolErr" },
	/*::[*/0x020E/*::]*/: { n:"BrtVolStr" },
	/*::[*/0x020F/*::]*/: { n:"BrtVolBool" },
	/*::[*/0x0210/*::]*/: { n:"BrtBeginCalcChain$" },
	/*::[*/0x0211/*::]*/: { n:"BrtEndCalcChain$" },
	/*::[*/0x0212/*::]*/: { n:"BrtBeginSortState" },
	/*::[*/0x0213/*::]*/: { n:"BrtEndSortState" },
	/*::[*/0x0214/*::]*/: { n:"BrtBeginSortCond" },
	/*::[*/0x0215/*::]*/: { n:"BrtEndSortCond" },
	/*::[*/0x0216/*::]*/: { n:"BrtBookProtection" },
	/*::[*/0x0217/*::]*/: { n:"BrtSheetProtection" },
	/*::[*/0x0218/*::]*/: { n:"BrtRangeProtection" },
	/*::[*/0x0219/*::]*/: { n:"BrtPhoneticInfo" },
	/*::[*/0x021A/*::]*/: { n:"BrtBeginECTxtWiz" },
	/*::[*/0x021B/*::]*/: { n:"BrtEndECTxtWiz" },
	/*::[*/0x021C/*::]*/: { n:"BrtBeginECTWFldInfoLst" },
	/*::[*/0x021D/*::]*/: { n:"BrtEndECTWFldInfoLst" },
	/*::[*/0x021E/*::]*/: { n:"BrtBeginECTwFldInfo" },
	/*::[*/0x0224/*::]*/: { n:"BrtFileSharing" },
	/*::[*/0x0225/*::]*/: { n:"BrtOleSize" },
	/*::[*/0x0226/*::]*/: { n:"BrtDrawing", f:parse_RelID },
	/*::[*/0x0227/*::]*/: { n:"BrtLegacyDrawing" },
	/*::[*/0x0228/*::]*/: { n:"BrtLegacyDrawingHF" },
	/*::[*/0x0229/*::]*/: { n:"BrtWebOpt" },
	/*::[*/0x022A/*::]*/: { n:"BrtBeginWebPubItems" },
	/*::[*/0x022B/*::]*/: { n:"BrtEndWebPubItems" },
	/*::[*/0x022C/*::]*/: { n:"BrtBeginWebPubItem" },
	/*::[*/0x022D/*::]*/: { n:"BrtEndWebPubItem" },
	/*::[*/0x022E/*::]*/: { n:"BrtBeginSXCondFmt" },
	/*::[*/0x022F/*::]*/: { n:"BrtEndSXCondFmt" },
	/*::[*/0x0230/*::]*/: { n:"BrtBeginSXCondFmts" },
	/*::[*/0x0231/*::]*/: { n:"BrtEndSXCondFmts" },
	/*::[*/0x0232/*::]*/: { n:"BrtBkHim" },
	/*::[*/0x0234/*::]*/: { n:"BrtColor" },
	/*::[*/0x0235/*::]*/: { n:"BrtBeginIndexedColors" },
	/*::[*/0x0236/*::]*/: { n:"BrtEndIndexedColors" },
	/*::[*/0x0239/*::]*/: { n:"BrtBeginMRUColors" },
	/*::[*/0x023A/*::]*/: { n:"BrtEndMRUColors" },
	/*::[*/0x023C/*::]*/: { n:"BrtMRUColor" },
	/*::[*/0x023D/*::]*/: { n:"BrtBeginDVals" },
	/*::[*/0x023E/*::]*/: { n:"BrtEndDVals" },
	/*::[*/0x0241/*::]*/: { n:"BrtSupNameStart" },
	/*::[*/0x0242/*::]*/: { n:"BrtSupNameValueStart" },
	/*::[*/0x0243/*::]*/: { n:"BrtSupNameValueEnd" },
	/*::[*/0x0244/*::]*/: { n:"BrtSupNameNum" },
	/*::[*/0x0245/*::]*/: { n:"BrtSupNameErr" },
	/*::[*/0x0246/*::]*/: { n:"BrtSupNameSt" },
	/*::[*/0x0247/*::]*/: { n:"BrtSupNameNil" },
	/*::[*/0x0248/*::]*/: { n:"BrtSupNameBool" },
	/*::[*/0x0249/*::]*/: { n:"BrtSupNameFmla" },
	/*::[*/0x024A/*::]*/: { n:"BrtSupNameBits" },
	/*::[*/0x024B/*::]*/: { n:"BrtSupNameEnd" },
	/*::[*/0x024C/*::]*/: { n:"BrtEndSupBook" },
	/*::[*/0x024D/*::]*/: { n:"BrtCellSmartTagProperty" },
	/*::[*/0x024E/*::]*/: { n:"BrtBeginCellSmartTag" },
	/*::[*/0x024F/*::]*/: { n:"BrtEndCellSmartTag" },
	/*::[*/0x0250/*::]*/: { n:"BrtBeginCellSmartTags" },
	/*::[*/0x0251/*::]*/: { n:"BrtEndCellSmartTags" },
	/*::[*/0x0252/*::]*/: { n:"BrtBeginSmartTags" },
	/*::[*/0x0253/*::]*/: { n:"BrtEndSmartTags" },
	/*::[*/0x0254/*::]*/: { n:"BrtSmartTagType" },
	/*::[*/0x0255/*::]*/: { n:"BrtBeginSmartTagTypes" },
	/*::[*/0x0256/*::]*/: { n:"BrtEndSmartTagTypes" },
	/*::[*/0x0257/*::]*/: { n:"BrtBeginSXFilters" },
	/*::[*/0x0258/*::]*/: { n:"BrtEndSXFilters" },
	/*::[*/0x0259/*::]*/: { n:"BrtBeginSXFILTER" },
	/*::[*/0x025A/*::]*/: { n:"BrtEndSXFilter" },
	/*::[*/0x025B/*::]*/: { n:"BrtBeginFills" },
	/*::[*/0x025C/*::]*/: { n:"BrtEndFills" },
	/*::[*/0x025D/*::]*/: { n:"BrtBeginCellWatches" },
	/*::[*/0x025E/*::]*/: { n:"BrtEndCellWatches" },
	/*::[*/0x025F/*::]*/: { n:"BrtCellWatch" },
	/*::[*/0x0260/*::]*/: { n:"BrtBeginCRErrs" },
	/*::[*/0x0261/*::]*/: { n:"BrtEndCRErrs" },
	/*::[*/0x0262/*::]*/: { n:"BrtCrashRecErr" },
	/*::[*/0x0263/*::]*/: { n:"BrtBeginFonts" },
	/*::[*/0x0264/*::]*/: { n:"BrtEndFonts" },
	/*::[*/0x0265/*::]*/: { n:"BrtBeginBorders" },
	/*::[*/0x0266/*::]*/: { n:"BrtEndBorders" },
	/*::[*/0x0267/*::]*/: { n:"BrtBeginFmts" },
	/*::[*/0x0268/*::]*/: { n:"BrtEndFmts" },
	/*::[*/0x0269/*::]*/: { n:"BrtBeginCellXFs" },
	/*::[*/0x026A/*::]*/: { n:"BrtEndCellXFs" },
	/*::[*/0x026B/*::]*/: { n:"BrtBeginStyles" },
	/*::[*/0x026C/*::]*/: { n:"BrtEndStyles" },
	/*::[*/0x0271/*::]*/: { n:"BrtBigName" },
	/*::[*/0x0272/*::]*/: { n:"BrtBeginCellStyleXFs" },
	/*::[*/0x0273/*::]*/: { n:"BrtEndCellStyleXFs" },
	/*::[*/0x0274/*::]*/: { n:"BrtBeginComments" },
	/*::[*/0x0275/*::]*/: { n:"BrtEndComments" },
	/*::[*/0x0276/*::]*/: { n:"BrtBeginCommentAuthors" },
	/*::[*/0x0277/*::]*/: { n:"BrtEndCommentAuthors" },
	/*::[*/0x0278/*::]*/: { n:"BrtCommentAuthor", f:parse_BrtCommentAuthor },
	/*::[*/0x0279/*::]*/: { n:"BrtBeginCommentList" },
	/*::[*/0x027A/*::]*/: { n:"BrtEndCommentList" },
	/*::[*/0x027B/*::]*/: { n:"BrtBeginComment", f:parse_BrtBeginComment},
	/*::[*/0x027C/*::]*/: { n:"BrtEndComment" },
	/*::[*/0x027D/*::]*/: { n:"BrtCommentText", f:parse_BrtCommentText },
	/*::[*/0x027E/*::]*/: { n:"BrtBeginOleObjects" },
	/*::[*/0x027F/*::]*/: { n:"BrtOleObject" },
	/*::[*/0x0280/*::]*/: { n:"BrtEndOleObjects" },
	/*::[*/0x0281/*::]*/: { n:"BrtBeginSxrules" },
	/*::[*/0x0282/*::]*/: { n:"BrtEndSxRules" },
	/*::[*/0x0283/*::]*/: { n:"BrtBeginActiveXControls" },
	/*::[*/0x0284/*::]*/: { n:"BrtActiveX" },
	/*::[*/0x0285/*::]*/: { n:"BrtEndActiveXControls" },
	/*::[*/0x0286/*::]*/: { n:"BrtBeginPCDSDTCEMembersSortBy" },
	/*::[*/0x0288/*::]*/: { n:"BrtBeginCellIgnoreECs" },
	/*::[*/0x0289/*::]*/: { n:"BrtCellIgnoreEC" },
	/*::[*/0x028A/*::]*/: { n:"BrtEndCellIgnoreECs" },
	/*::[*/0x028B/*::]*/: { n:"BrtCsProp", f:parse_BrtCsProp },
	/*::[*/0x028C/*::]*/: { n:"BrtCsPageSetup" },
	/*::[*/0x028D/*::]*/: { n:"BrtBeginUserCsViews" },
	/*::[*/0x028E/*::]*/: { n:"BrtEndUserCsViews" },
	/*::[*/0x028F/*::]*/: { n:"BrtBeginUserCsView" },
	/*::[*/0x0290/*::]*/: { n:"BrtEndUserCsView" },
	/*::[*/0x0291/*::]*/: { n:"BrtBeginPcdSFCIEntries" },
	/*::[*/0x0292/*::]*/: { n:"BrtEndPCDSFCIEntries" },
	/*::[*/0x0293/*::]*/: { n:"BrtPCDSFCIEntry" },
	/*::[*/0x0294/*::]*/: { n:"BrtBeginListParts" },
	/*::[*/0x0295/*::]*/: { n:"BrtListPart" },
	/*::[*/0x0296/*::]*/: { n:"BrtEndListParts" },
	/*::[*/0x0297/*::]*/: { n:"BrtSheetCalcProp" },
	/*::[*/0x0298/*::]*/: { n:"BrtBeginFnGroup" },
	/*::[*/0x0299/*::]*/: { n:"BrtFnGroup" },
	/*::[*/0x029A/*::]*/: { n:"BrtEndFnGroup" },
	/*::[*/0x029B/*::]*/: { n:"BrtSupAddin" },
	/*::[*/0x029C/*::]*/: { n:"BrtSXTDMPOrder" },
	/*::[*/0x029D/*::]*/: { n:"BrtCsProtection" },
	/*::[*/0x029F/*::]*/: { n:"BrtBeginWsSortMap" },
	/*::[*/0x02A0/*::]*/: { n:"BrtEndWsSortMap" },
	/*::[*/0x02A1/*::]*/: { n:"BrtBeginRRSort" },
	/*::[*/0x02A2/*::]*/: { n:"BrtEndRRSort" },
	/*::[*/0x02A3/*::]*/: { n:"BrtRRSortItem" },
	/*::[*/0x02A4/*::]*/: { n:"BrtFileSharingIso" },
	/*::[*/0x02A5/*::]*/: { n:"BrtBookProtectionIso" },
	/*::[*/0x02A6/*::]*/: { n:"BrtSheetProtectionIso" },
	/*::[*/0x02A7/*::]*/: { n:"BrtCsProtectionIso" },
	/*::[*/0x02A8/*::]*/: { n:"BrtRangeProtectionIso" },
	/*::[*/0x02A9/*::]*/: { n:"BrtDValList" },
	/*::[*/0x0400/*::]*/: { n:"BrtRwDescent" },
	/*::[*/0x0401/*::]*/: { n:"BrtKnownFonts" },
	/*::[*/0x0402/*::]*/: { n:"BrtBeginSXTupleSet" },
	/*::[*/0x0403/*::]*/: { n:"BrtEndSXTupleSet" },
	/*::[*/0x0404/*::]*/: { n:"BrtBeginSXTupleSetHeader" },
	/*::[*/0x0405/*::]*/: { n:"BrtEndSXTupleSetHeader" },
	/*::[*/0x0406/*::]*/: { n:"BrtSXTupleSetHeaderItem" },
	/*::[*/0x0407/*::]*/: { n:"BrtBeginSXTupleSetData" },
	/*::[*/0x0408/*::]*/: { n:"BrtEndSXTupleSetData" },
	/*::[*/0x0409/*::]*/: { n:"BrtBeginSXTupleSetRow" },
	/*::[*/0x040A/*::]*/: { n:"BrtEndSXTupleSetRow" },
	/*::[*/0x040B/*::]*/: { n:"BrtSXTupleSetRowItem" },
	/*::[*/0x040C/*::]*/: { n:"BrtNameExt" },
	/*::[*/0x040D/*::]*/: { n:"BrtPCDH14" },
	/*::[*/0x040E/*::]*/: { n:"BrtBeginPCDCalcMem14" },
	/*::[*/0x040F/*::]*/: { n:"BrtEndPCDCalcMem14" },
	/*::[*/0x0410/*::]*/: { n:"BrtSXTH14" },
	/*::[*/0x0411/*::]*/: { n:"BrtBeginSparklineGroup" },
	/*::[*/0x0412/*::]*/: { n:"BrtEndSparklineGroup" },
	/*::[*/0x0413/*::]*/: { n:"BrtSparkline" },
	/*::[*/0x0414/*::]*/: { n:"BrtSXDI14" },
	/*::[*/0x0415/*::]*/: { n:"BrtWsFmtInfoEx14" },
	/*::[*/0x0416/*::]*/: { n:"BrtBeginConditionalFormatting14" },
	/*::[*/0x0417/*::]*/: { n:"BrtEndConditionalFormatting14" },
	/*::[*/0x0418/*::]*/: { n:"BrtBeginCFRule14" },
	/*::[*/0x0419/*::]*/: { n:"BrtEndCFRule14" },
	/*::[*/0x041A/*::]*/: { n:"BrtCFVO14" },
	/*::[*/0x041B/*::]*/: { n:"BrtBeginDatabar14" },
	/*::[*/0x041C/*::]*/: { n:"BrtBeginIconSet14" },
	/*::[*/0x041D/*::]*/: { n:"BrtDVal14", f: parse_BrtDVal14 },
	/*::[*/0x041E/*::]*/: { n:"BrtBeginDVals14" },
	/*::[*/0x041F/*::]*/: { n:"BrtColor14" },
	/*::[*/0x0420/*::]*/: { n:"BrtBeginSparklines" },
	/*::[*/0x0421/*::]*/: { n:"BrtEndSparklines" },
	/*::[*/0x0422/*::]*/: { n:"BrtBeginSparklineGroups" },
	/*::[*/0x0423/*::]*/: { n:"BrtEndSparklineGroups" },
	/*::[*/0x0425/*::]*/: { n:"BrtSXVD14" },
	/*::[*/0x0426/*::]*/: { n:"BrtBeginSXView14" },
	/*::[*/0x0427/*::]*/: { n:"BrtEndSXView14" },
	/*::[*/0x0428/*::]*/: { n:"BrtBeginSXView16" },
	/*::[*/0x0429/*::]*/: { n:"BrtEndSXView16" },
	/*::[*/0x042A/*::]*/: { n:"BrtBeginPCD14" },
	/*::[*/0x042B/*::]*/: { n:"BrtEndPCD14" },
	/*::[*/0x042C/*::]*/: { n:"BrtBeginExtConn14" },
	/*::[*/0x042D/*::]*/: { n:"BrtEndExtConn14" },
	/*::[*/0x042E/*::]*/: { n:"BrtBeginSlicerCacheIDs" },
	/*::[*/0x042F/*::]*/: { n:"BrtEndSlicerCacheIDs" },
	/*::[*/0x0430/*::]*/: { n:"BrtBeginSlicerCacheID" },
	/*::[*/0x0431/*::]*/: { n:"BrtEndSlicerCacheID" },
	/*::[*/0x0433/*::]*/: { n:"BrtBeginSlicerCache" },
	/*::[*/0x0434/*::]*/: { n:"BrtEndSlicerCache" },
	/*::[*/0x0435/*::]*/: { n:"BrtBeginSlicerCacheDef" },
	/*::[*/0x0436/*::]*/: { n:"BrtEndSlicerCacheDef" },
	/*::[*/0x0437/*::]*/: { n:"BrtBeginSlicersEx" },
	/*::[*/0x0438/*::]*/: { n:"BrtEndSlicersEx" },
	/*::[*/0x0439/*::]*/: { n:"BrtBeginSlicerEx" },
	/*::[*/0x043A/*::]*/: { n:"BrtEndSlicerEx" },
	/*::[*/0x043B/*::]*/: { n:"BrtBeginSlicer" },
	/*::[*/0x043C/*::]*/: { n:"BrtEndSlicer" },
	/*::[*/0x043D/*::]*/: { n:"BrtSlicerCachePivotTables" },
	/*::[*/0x043E/*::]*/: { n:"BrtBeginSlicerCacheOlapImpl" },
	/*::[*/0x043F/*::]*/: { n:"BrtEndSlicerCacheOlapImpl" },
	/*::[*/0x0440/*::]*/: { n:"BrtBeginSlicerCacheLevelsData" },
	/*::[*/0x0441/*::]*/: { n:"BrtEndSlicerCacheLevelsData" },
	/*::[*/0x0442/*::]*/: { n:"BrtBeginSlicerCacheLevelData" },
	/*::[*/0x0443/*::]*/: { n:"BrtEndSlicerCacheLevelData" },
	/*::[*/0x0444/*::]*/: { n:"BrtBeginSlicerCacheSiRanges" },
	/*::[*/0x0445/*::]*/: { n:"BrtEndSlicerCacheSiRanges" },
	/*::[*/0x0446/*::]*/: { n:"BrtBeginSlicerCacheSiRange" },
	/*::[*/0x0447/*::]*/: { n:"BrtEndSlicerCacheSiRange" },
	/*::[*/0x0448/*::]*/: { n:"BrtSlicerCacheOlapItem" },
	/*::[*/0x0449/*::]*/: { n:"BrtBeginSlicerCacheSelections" },
	/*::[*/0x044A/*::]*/: { n:"BrtSlicerCacheSelection" },
	/*::[*/0x044B/*::]*/: { n:"BrtEndSlicerCacheSelections" },
	/*::[*/0x044C/*::]*/: { n:"BrtBeginSlicerCacheNative" },
	/*::[*/0x044D/*::]*/: { n:"BrtEndSlicerCacheNative" },
	/*::[*/0x044E/*::]*/: { n:"BrtSlicerCacheNativeItem" },
	/*::[*/0x044F/*::]*/: { n:"BrtRangeProtection14" },
	/*::[*/0x0450/*::]*/: { n:"BrtRangeProtectionIso14" },
	/*::[*/0x0451/*::]*/: { n:"BrtCellIgnoreEC14" },
	/*::[*/0x0457/*::]*/: { n:"BrtList14" },
	/*::[*/0x0458/*::]*/: { n:"BrtCFIcon" },
	/*::[*/0x0459/*::]*/: { n:"BrtBeginSlicerCachesPivotCacheIDs" },
	/*::[*/0x045A/*::]*/: { n:"BrtEndSlicerCachesPivotCacheIDs" },
	/*::[*/0x045B/*::]*/: { n:"BrtBeginSlicers" },
	/*::[*/0x045C/*::]*/: { n:"BrtEndSlicers" },
	/*::[*/0x045D/*::]*/: { n:"BrtWbProp14" },
	/*::[*/0x045E/*::]*/: { n:"BrtBeginSXEdit" },
	/*::[*/0x045F/*::]*/: { n:"BrtEndSXEdit" },
	/*::[*/0x0460/*::]*/: { n:"BrtBeginSXEdits" },
	/*::[*/0x0461/*::]*/: { n:"BrtEndSXEdits" },
	/*::[*/0x0462/*::]*/: { n:"BrtBeginSXChange" },
	/*::[*/0x0463/*::]*/: { n:"BrtEndSXChange" },
	/*::[*/0x0464/*::]*/: { n:"BrtBeginSXChanges" },
	/*::[*/0x0465/*::]*/: { n:"BrtEndSXChanges" },
	/*::[*/0x0466/*::]*/: { n:"BrtSXTupleItems" },
	/*::[*/0x0468/*::]*/: { n:"BrtBeginSlicerStyle" },
	/*::[*/0x0469/*::]*/: { n:"BrtEndSlicerStyle" },
	/*::[*/0x046A/*::]*/: { n:"BrtSlicerStyleElement" },
	/*::[*/0x046B/*::]*/: { n:"BrtBeginStyleSheetExt14" },
	/*::[*/0x046C/*::]*/: { n:"BrtEndStyleSheetExt14" },
	/*::[*/0x046D/*::]*/: { n:"BrtBeginSlicerCachesPivotCacheID" },
	/*::[*/0x046E/*::]*/: { n:"BrtEndSlicerCachesPivotCacheID" },
	/*::[*/0x046F/*::]*/: { n:"BrtBeginConditionalFormattings" },
	/*::[*/0x0470/*::]*/: { n:"BrtEndConditionalFormattings" },
	/*::[*/0x0471/*::]*/: { n:"BrtBeginPCDCalcMemExt" },
	/*::[*/0x0472/*::]*/: { n:"BrtEndPCDCalcMemExt" },
	/*::[*/0x0473/*::]*/: { n:"BrtBeginPCDCalcMemsExt" },
	/*::[*/0x0474/*::]*/: { n:"BrtEndPCDCalcMemsExt" },
	/*::[*/0x0475/*::]*/: { n:"BrtPCDField14" },
	/*::[*/0x0476/*::]*/: { n:"BrtBeginSlicerStyles" },
	/*::[*/0x0477/*::]*/: { n:"BrtEndSlicerStyles" },
	/*::[*/0x0478/*::]*/: { n:"BrtBeginSlicerStyleElements" },
	/*::[*/0x0479/*::]*/: { n:"BrtEndSlicerStyleElements" },
	/*::[*/0x047A/*::]*/: { n:"BrtCFRuleExt" },
	/*::[*/0x047B/*::]*/: { n:"BrtBeginSXCondFmt14" },
	/*::[*/0x047C/*::]*/: { n:"BrtEndSXCondFmt14" },
	/*::[*/0x047D/*::]*/: { n:"BrtBeginSXCondFmts14" },
	/*::[*/0x047E/*::]*/: { n:"BrtEndSXCondFmts14" },
	/*::[*/0x0480/*::]*/: { n:"BrtBeginSortCond14" },
	/*::[*/0x0481/*::]*/: { n:"BrtEndSortCond14" },
	/*::[*/0x0482/*::]*/: { n:"BrtEndDVals14" },
	/*::[*/0x0483/*::]*/: { n:"BrtEndIconSet14" },
	/*::[*/0x0484/*::]*/: { n:"BrtEndDatabar14" },
	/*::[*/0x0485/*::]*/: { n:"BrtBeginColorScale14" },
	/*::[*/0x0486/*::]*/: { n:"BrtEndColorScale14" },
	/*::[*/0x0487/*::]*/: { n:"BrtBeginSxrules14" },
	/*::[*/0x0488/*::]*/: { n:"BrtEndSxrules14" },
	/*::[*/0x0489/*::]*/: { n:"BrtBeginPRule14" },
	/*::[*/0x048A/*::]*/: { n:"BrtEndPRule14" },
	/*::[*/0x048B/*::]*/: { n:"BrtBeginPRFilters14" },
	/*::[*/0x048C/*::]*/: { n:"BrtEndPRFilters14" },
	/*::[*/0x048D/*::]*/: { n:"BrtBeginPRFilter14" },
	/*::[*/0x048E/*::]*/: { n:"BrtEndPRFilter14" },
	/*::[*/0x048F/*::]*/: { n:"BrtBeginPRFItem14" },
	/*::[*/0x0490/*::]*/: { n:"BrtEndPRFItem14" },
	/*::[*/0x0491/*::]*/: { n:"BrtBeginCellIgnoreECs14" },
	/*::[*/0x0492/*::]*/: { n:"BrtEndCellIgnoreECs14" },
	/*::[*/0x0493/*::]*/: { n:"BrtDxf14" },
	/*::[*/0x0494/*::]*/: { n:"BrtBeginDxF14s" },
	/*::[*/0x0495/*::]*/: { n:"BrtEndDxf14s" },
	/*::[*/0x0499/*::]*/: { n:"BrtFilter14" },
	/*::[*/0x049A/*::]*/: { n:"BrtBeginCustomFilters14" },
	/*::[*/0x049C/*::]*/: { n:"BrtCustomFilter14" },
	/*::[*/0x049D/*::]*/: { n:"BrtIconFilter14" },
	/*::[*/0x049E/*::]*/: { n:"BrtPivotCacheConnectionName" },
	/*::[*/0x0800/*::]*/: { n:"BrtBeginDecoupledPivotCacheIDs" },
	/*::[*/0x0801/*::]*/: { n:"BrtEndDecoupledPivotCacheIDs" },
	/*::[*/0x0802/*::]*/: { n:"BrtDecoupledPivotCacheID" },
	/*::[*/0x0803/*::]*/: { n:"BrtBeginPivotTableRefs" },
	/*::[*/0x0804/*::]*/: { n:"BrtEndPivotTableRefs" },
	/*::[*/0x0805/*::]*/: { n:"BrtPivotTableRef" },
	/*::[*/0x0806/*::]*/: { n:"BrtSlicerCacheBookPivotTables" },
	/*::[*/0x0807/*::]*/: { n:"BrtBeginSxvcells" },
	/*::[*/0x0808/*::]*/: { n:"BrtEndSxvcells" },
	/*::[*/0x0809/*::]*/: { n:"BrtBeginSxRow" },
	/*::[*/0x080A/*::]*/: { n:"BrtEndSxRow" },
	/*::[*/0x080C/*::]*/: { n:"BrtPcdCalcMem15" },
	/*::[*/0x0813/*::]*/: { n:"BrtQsi15" },
	/*::[*/0x0814/*::]*/: { n:"BrtBeginWebExtensions" },
	/*::[*/0x0815/*::]*/: { n:"BrtEndWebExtensions" },
	/*::[*/0x0816/*::]*/: { n:"BrtWebExtension" },
	/*::[*/0x0817/*::]*/: { n:"BrtAbsPath15" },
	/*::[*/0x0818/*::]*/: { n:"BrtBeginPivotTableUISettings" },
	/*::[*/0x0819/*::]*/: { n:"BrtEndPivotTableUISettings" },
	/*::[*/0x081B/*::]*/: { n:"BrtTableSlicerCacheIDs" },
	/*::[*/0x081C/*::]*/: { n:"BrtTableSlicerCacheID" },
	/*::[*/0x081D/*::]*/: { n:"BrtBeginTableSlicerCache" },
	/*::[*/0x081E/*::]*/: { n:"BrtEndTableSlicerCache" },
	/*::[*/0x081F/*::]*/: { n:"BrtSxFilter15" },
	/*::[*/0x0820/*::]*/: { n:"BrtBeginTimelineCachePivotCacheIDs" },
	/*::[*/0x0821/*::]*/: { n:"BrtEndTimelineCachePivotCacheIDs" },
	/*::[*/0x0822/*::]*/: { n:"BrtTimelineCachePivotCacheID" },
	/*::[*/0x0823/*::]*/: { n:"BrtBeginTimelineCacheIDs" },
	/*::[*/0x0824/*::]*/: { n:"BrtEndTimelineCacheIDs" },
	/*::[*/0x0825/*::]*/: { n:"BrtBeginTimelineCacheID" },
	/*::[*/0x0826/*::]*/: { n:"BrtEndTimelineCacheID" },
	/*::[*/0x0827/*::]*/: { n:"BrtBeginTimelinesEx" },
	/*::[*/0x0828/*::]*/: { n:"BrtEndTimelinesEx" },
	/*::[*/0x0829/*::]*/: { n:"BrtBeginTimelineEx" },
	/*::[*/0x082A/*::]*/: { n:"BrtEndTimelineEx" },
	/*::[*/0x082B/*::]*/: { n:"BrtWorkBookPr15" },
	/*::[*/0x082C/*::]*/: { n:"BrtPCDH15" },
	/*::[*/0x082D/*::]*/: { n:"BrtBeginTimelineStyle" },
	/*::[*/0x082E/*::]*/: { n:"BrtEndTimelineStyle" },
	/*::[*/0x082F/*::]*/: { n:"BrtTimelineStyleElement" },
	/*::[*/0x0830/*::]*/: { n:"BrtBeginTimelineStylesheetExt15" },
	/*::[*/0x0831/*::]*/: { n:"BrtEndTimelineStylesheetExt15" },
	/*::[*/0x0832/*::]*/: { n:"BrtBeginTimelineStyles" },
	/*::[*/0x0833/*::]*/: { n:"BrtEndTimelineStyles" },
	/*::[*/0x0834/*::]*/: { n:"BrtBeginTimelineStyleElements" },
	/*::[*/0x0835/*::]*/: { n:"BrtEndTimelineStyleElements" },
	/*::[*/0x0836/*::]*/: { n:"BrtDxf15" },
	/*::[*/0x0837/*::]*/: { n:"BrtBeginDxfs15" },
	/*::[*/0x0838/*::]*/: { n:"brtEndDxfs15" },
	/*::[*/0x0839/*::]*/: { n:"BrtSlicerCacheHideItemsWithNoData" },
	/*::[*/0x083A/*::]*/: { n:"BrtBeginItemUniqueNames" },
	/*::[*/0x083B/*::]*/: { n:"BrtEndItemUniqueNames" },
	/*::[*/0x083C/*::]*/: { n:"BrtItemUniqueName" },
	/*::[*/0x083D/*::]*/: { n:"BrtBeginExtConn15" },
	/*::[*/0x083E/*::]*/: { n:"BrtEndExtConn15" },
	/*::[*/0x083F/*::]*/: { n:"BrtBeginOledbPr15" },
	/*::[*/0x0840/*::]*/: { n:"BrtEndOledbPr15" },
	/*::[*/0x0841/*::]*/: { n:"BrtBeginDataFeedPr15" },
	/*::[*/0x0842/*::]*/: { n:"BrtEndDataFeedPr15" },
	/*::[*/0x0843/*::]*/: { n:"BrtTextPr15" },
	/*::[*/0x0844/*::]*/: { n:"BrtRangePr15" },
	/*::[*/0x0845/*::]*/: { n:"BrtDbCommand15" },
	/*::[*/0x0846/*::]*/: { n:"BrtBeginDbTables15" },
	/*::[*/0x0847/*::]*/: { n:"BrtEndDbTables15" },
	/*::[*/0x0848/*::]*/: { n:"BrtDbTable15" },
	/*::[*/0x0849/*::]*/: { n:"BrtBeginDataModel" },
	/*::[*/0x084A/*::]*/: { n:"BrtEndDataModel" },
	/*::[*/0x084B/*::]*/: { n:"BrtBeginModelTables" },
	/*::[*/0x084C/*::]*/: { n:"BrtEndModelTables" },
	/*::[*/0x084D/*::]*/: { n:"BrtModelTable" },
	/*::[*/0x084E/*::]*/: { n:"BrtBeginModelRelationships" },
	/*::[*/0x084F/*::]*/: { n:"BrtEndModelRelationships" },
	/*::[*/0x0850/*::]*/: { n:"BrtModelRelationship" },
	/*::[*/0x0851/*::]*/: { n:"BrtBeginECTxtWiz15" },
	/*::[*/0x0852/*::]*/: { n:"BrtEndECTxtWiz15" },
	/*::[*/0x0853/*::]*/: { n:"BrtBeginECTWFldInfoLst15" },
	/*::[*/0x0854/*::]*/: { n:"BrtEndECTWFldInfoLst15" },
	/*::[*/0x0855/*::]*/: { n:"BrtBeginECTWFldInfo15" },
	/*::[*/0x0856/*::]*/: { n:"BrtFieldListActiveItem" },
	/*::[*/0x0857/*::]*/: { n:"BrtPivotCacheIdVersion" },
	/*::[*/0x0858/*::]*/: { n:"BrtSXDI15" },
	/*::[*/0x0859/*::]*/: { n:"BrtBeginModelTimeGroupings" },
	/*::[*/0x085A/*::]*/: { n:"BrtEndModelTimeGroupings" },
	/*::[*/0x085B/*::]*/: { n:"BrtBeginModelTimeGrouping" },
	/*::[*/0x085C/*::]*/: { n:"BrtEndModelTimeGrouping" },
	/*::[*/0x085D/*::]*/: { n:"BrtModelTimeGroupingCalcCol" },
	/*::[*/0x0C00/*::]*/: { n:"BrtUid" },
	/*::[*/0x0C01/*::]*/: { n:"BrtRevisionPtr" },
	/*::[*/0x13e7/*::]*/: { n:"BrtBeginCalcFeatures" },
	/*::[*/0x13e8/*::]*/: { n:"BrtEndCalcFeatures" },
	/*::[*/0x13e9/*::]*/: { n:"BrtCalcFeature" },
	/*::[*/0xFFFF/*::]*/: { n:"" }
};

var XLSBRE = evert_key(XLSBRecordEnum, 'n');
/*jshint -W069 */
XLSBRE["BrtFRTArchID$"] = 0x0010;
/*jshint +W069 */

/* [MS-XLS] 2.3 Record Enumeration (and other sources) */
var XLSRecordEnum = {
	/* [MS-XLS] 2.3 Record Enumeration 2021-08-17 */
	/*::[*/0x0006/*::]*/: { n:"Formula", f:parse_Formula },
	/*::[*/0x000a/*::]*/: { n:'EOF', f:parsenoop2 },
	/*::[*/0x000c/*::]*/: { n:"CalcCount", f:parseuint16 },
	/*::[*/0x000d/*::]*/: { n:"CalcMode", f:parseuint16 },
	/*::[*/0x000e/*::]*/: { n:"CalcPrecision", f:parsebool },
	/*::[*/0x000f/*::]*/: { n:"CalcRefMode", f:parsebool },
	/*::[*/0x0010/*::]*/: { n:"CalcDelta", f:parse_Xnum },
	/*::[*/0x0011/*::]*/: { n:"CalcIter", f:parsebool },
	/*::[*/0x0012/*::]*/: { n:"Protect", f:parsebool },
	/*::[*/0x0013/*::]*/: { n:"Password", f:parseuint16 },
	/*::[*/0x0014/*::]*/: { n:"Header", f:parse_XLHeaderFooter },
	/*::[*/0x0015/*::]*/: { n:"Footer", f:parse_XLHeaderFooter },
	/*::[*/0x0017/*::]*/: { n:"ExternSheet", f:parse_ExternSheet },
	/*::[*/0x0018/*::]*/: { n:"Lbl", f:parse_Lbl },
	/*::[*/0x0019/*::]*/: { n:"WinProtect", f:parsebool },
	/*::[*/0x001a/*::]*/: { n:"VerticalPageBreaks" },
	/*::[*/0x001b/*::]*/: { n:"HorizontalPageBreaks" },
	/*::[*/0x001c/*::]*/: { n:"Note", f:parse_Note },
	/*::[*/0x001d/*::]*/: { n:"Selection" },
	/*::[*/0x0022/*::]*/: { n:"Date1904", f:parsebool },
	/*::[*/0x0023/*::]*/: { n:"ExternName", f:parse_ExternName },
	/*::[*/0x0026/*::]*/: { n:"LeftMargin", f:parse_Xnum },
	/*::[*/0x0027/*::]*/: { n:"RightMargin", f:parse_Xnum },
	/*::[*/0x0028/*::]*/: { n:"TopMargin", f:parse_Xnum },
	/*::[*/0x0029/*::]*/: { n:"BottomMargin", f:parse_Xnum },
	/*::[*/0x002a/*::]*/: { n:"PrintRowCol", f:parsebool },
	/*::[*/0x002b/*::]*/: { n:"PrintGrid", f:parsebool },
	/*::[*/0x002f/*::]*/: { n:"FilePass", f:parse_FilePass },
	/*::[*/0x0031/*::]*/: { n:"Font", f:parse_Font },
	/*::[*/0x0033/*::]*/: { n:"PrintSize", f:parseuint16 },
	/*::[*/0x003c/*::]*/: { n:"Continue" },
	/*::[*/0x003d/*::]*/: { n:"Window1", f:parse_Window1 },
	/*::[*/0x0040/*::]*/: { n:"Backup", f:parsebool },
	/*::[*/0x0041/*::]*/: { n:"Pane", f:parse_Pane },
	/*::[*/0x0042/*::]*/: { n:'CodePage', f:parseuint16 },
	/*::[*/0x004d/*::]*/: { n:"Pls" },
	/*::[*/0x0050/*::]*/: { n:"DCon" },
	/*::[*/0x0051/*::]*/: { n:"DConRef" },
	/*::[*/0x0052/*::]*/: { n:"DConName" },
	/*::[*/0x0055/*::]*/: { n:"DefColWidth", f:parseuint16 },
	/*::[*/0x0059/*::]*/: { n:"XCT" },
	/*::[*/0x005a/*::]*/: { n:"CRN" },
	/*::[*/0x005b/*::]*/: { n:"FileSharing" },
	/*::[*/0x005c/*::]*/: { n:'WriteAccess', f:parse_WriteAccess },
	/*::[*/0x005d/*::]*/: { n:"Obj", f:parse_Obj },
	/*::[*/0x005e/*::]*/: { n:"Uncalced" },
	/*::[*/0x005f/*::]*/: { n:"CalcSaveRecalc", f:parsebool },
	/*::[*/0x0060/*::]*/: { n:"Template" },
	/*::[*/0x0061/*::]*/: { n:"Intl" },
	/*::[*/0x0063/*::]*/: { n:"ObjProtect", f:parsebool },
	/*::[*/0x007d/*::]*/: { n:"ColInfo", f:parse_ColInfo },
	/*::[*/0x0080/*::]*/: { n:"Guts", f:parse_Guts },
	/*::[*/0x0081/*::]*/: { n:"WsBool", f:parse_WsBool },
	/*::[*/0x0082/*::]*/: { n:"GridSet", f:parseuint16 },
	/*::[*/0x0083/*::]*/: { n:"HCenter", f:parsebool },
	/*::[*/0x0084/*::]*/: { n:"VCenter", f:parsebool },
	/*::[*/0x0085/*::]*/: { n:'BoundSheet8', f:parse_BoundSheet8 },
	/*::[*/0x0086/*::]*/: { n:"WriteProtect" },
	/*::[*/0x008c/*::]*/: { n:"Country", f:parse_Country },
	/*::[*/0x008d/*::]*/: { n:"HideObj", f:parseuint16 },
	/*::[*/0x0090/*::]*/: { n:"Sort" },
	/*::[*/0x0092/*::]*/: { n:"Palette", f:parse_Palette },
	/*::[*/0x0097/*::]*/: { n:"Sync" },
	/*::[*/0x0098/*::]*/: { n:"LPr" },
	/*::[*/0x0099/*::]*/: { n:"DxGCol" },
	/*::[*/0x009a/*::]*/: { n:"FnGroupName" },
	/*::[*/0x009b/*::]*/: { n:"FilterMode" },
	/*::[*/0x009c/*::]*/: { n:"BuiltInFnGroupCount", f:parseuint16 },
	/*::[*/0x009d/*::]*/: { n:"AutoFilterInfo" },
	/*::[*/0x009e/*::]*/: { n:"AutoFilter" },
	/*::[*/0x00a0/*::]*/: { n:"Scl", f:parse_Scl },
	/*::[*/0x00a1/*::]*/: { n:"Setup", f:parse_Setup },
	/*::[*/0x00ae/*::]*/: { n:"ScenMan" },
	/*::[*/0x00af/*::]*/: { n:"SCENARIO" },
	/*::[*/0x00b0/*::]*/: { n:"SxView" },
	/*::[*/0x00b1/*::]*/: { n:"Sxvd" },
	/*::[*/0x00b2/*::]*/: { n:"SXVI" },
	/*::[*/0x00b4/*::]*/: { n:"SxIvd" },
	/*::[*/0x00b5/*::]*/: { n:"SXLI" },
	/*::[*/0x00b6/*::]*/: { n:"SXPI" },
	/*::[*/0x00b8/*::]*/: { n:"DocRoute" },
	/*::[*/0x00b9/*::]*/: { n:"RecipName" },
	/*::[*/0x00bd/*::]*/: { n:"MulRk", f:parse_MulRk },
	/*::[*/0x00be/*::]*/: { n:"MulBlank", f:parse_MulBlank },
	/*::[*/0x00c1/*::]*/: { n:'Mms', f:parsenoop2 },
	/*::[*/0x00c5/*::]*/: { n:"SXDI" },
	/*::[*/0x00c6/*::]*/: { n:"SXDB" },
	/*::[*/0x00c7/*::]*/: { n:"SXFDB" },
	/*::[*/0x00c8/*::]*/: { n:"SXDBB" },
	/*::[*/0x00c9/*::]*/: { n:"SXNum" },
	/*::[*/0x00ca/*::]*/: { n:"SxBool", f:parsebool },
	/*::[*/0x00cb/*::]*/: { n:"SxErr" },
	/*::[*/0x00cc/*::]*/: { n:"SXInt" },
	/*::[*/0x00cd/*::]*/: { n:"SXString" },
	/*::[*/0x00ce/*::]*/: { n:"SXDtr" },
	/*::[*/0x00cf/*::]*/: { n:"SxNil" },
	/*::[*/0x00d0/*::]*/: { n:"SXTbl" },
	/*::[*/0x00d1/*::]*/: { n:"SXTBRGIITM" },
	/*::[*/0x00d2/*::]*/: { n:"SxTbpg" },
	/*::[*/0x00d3/*::]*/: { n:"ObProj" },
	/*::[*/0x00d5/*::]*/: { n:"SXStreamID" },
	/*::[*/0x00d7/*::]*/: { n:"DBCell" },
	/*::[*/0x00d8/*::]*/: { n:"SXRng" },
	/*::[*/0x00d9/*::]*/: { n:"SxIsxoper" },
	/*::[*/0x00da/*::]*/: { n:"BookBool", f:parseuint16 },
	/*::[*/0x00dc/*::]*/: { n:"DbOrParamQry" },
	/*::[*/0x00dd/*::]*/: { n:"ScenarioProtect", f:parsebool },
	/*::[*/0x00de/*::]*/: { n:"OleObjectSize" },
	/*::[*/0x00e0/*::]*/: { n:"XF", f:parse_XF },
	/*::[*/0x00e1/*::]*/: { n:'InterfaceHdr', f:parse_InterfaceHdr },
	/*::[*/0x00e2/*::]*/: { n:'InterfaceEnd', f:parsenoop2 },
	/*::[*/0x00e3/*::]*/: { n:"SXVS" },
	/*::[*/0x00e5/*::]*/: { n:"MergeCells", f:parse_MergeCells },
	/*::[*/0x00e9/*::]*/: { n:"BkHim" },
	/*::[*/0x00eb/*::]*/: { n:"MsoDrawingGroup" },
	/*::[*/0x00ec/*::]*/: { n:"MsoDrawing" },
	/*::[*/0x00ed/*::]*/: { n:"MsoDrawingSelection" },
	/*::[*/0x00ef/*::]*/: { n:"PhoneticInfo" },
	/*::[*/0x00f0/*::]*/: { n:"SxRule" },
	/*::[*/0x00f1/*::]*/: { n:"SXEx" },
	/*::[*/0x00f2/*::]*/: { n:"SxFilt" },
	/*::[*/0x00f4/*::]*/: { n:"SxDXF" },
	/*::[*/0x00f5/*::]*/: { n:"SxItm" },
	/*::[*/0x00f6/*::]*/: { n:"SxName" },
	/*::[*/0x00f7/*::]*/: { n:"SxSelect" },
	/*::[*/0x00f8/*::]*/: { n:"SXPair" },
	/*::[*/0x00f9/*::]*/: { n:"SxFmla" },
	/*::[*/0x00fb/*::]*/: { n:"SxFormat" },
	/*::[*/0x00fc/*::]*/: { n:"SST", f:parse_SST },
	/*::[*/0x00fd/*::]*/: { n:"LabelSst", f:parse_LabelSst },
	/*::[*/0x00ff/*::]*/: { n:"ExtSST", f:parse_ExtSST },
	/*::[*/0x0100/*::]*/: { n:"SXVDEx" },
	/*::[*/0x0103/*::]*/: { n:"SXFormula" },
	/*::[*/0x0122/*::]*/: { n:"SXDBEx" },
	/*::[*/0x0137/*::]*/: { n:"RRDInsDel" },
	/*::[*/0x0138/*::]*/: { n:"RRDHead" },
	/*::[*/0x013b/*::]*/: { n:"RRDChgCell" },
	/*::[*/0x013d/*::]*/: { n:"RRTabId", f:parseuint16a },
	/*::[*/0x013e/*::]*/: { n:"RRDRenSheet" },
	/*::[*/0x013f/*::]*/: { n:"RRSort" },
	/*::[*/0x0140/*::]*/: { n:"RRDMove" },
	/*::[*/0x014a/*::]*/: { n:"RRFormat" },
	/*::[*/0x014b/*::]*/: { n:"RRAutoFmt" },
	/*::[*/0x014d/*::]*/: { n:"RRInsertSh" },
	/*::[*/0x014e/*::]*/: { n:"RRDMoveBegin" },
	/*::[*/0x014f/*::]*/: { n:"RRDMoveEnd" },
	/*::[*/0x0150/*::]*/: { n:"RRDInsDelBegin" },
	/*::[*/0x0151/*::]*/: { n:"RRDInsDelEnd" },
	/*::[*/0x0152/*::]*/: { n:"RRDConflict" },
	/*::[*/0x0153/*::]*/: { n:"RRDDefName" },
	/*::[*/0x0154/*::]*/: { n:"RRDRstEtxp" },
	/*::[*/0x015f/*::]*/: { n:"LRng" },
	/*::[*/0x0160/*::]*/: { n:"UsesELFs", f:parsebool },
	/*::[*/0x0161/*::]*/: { n:"DSF", f:parsenoop2 },
	/*::[*/0x0191/*::]*/: { n:"CUsr" },
	/*::[*/0x0192/*::]*/: { n:"CbUsr" },
	/*::[*/0x0193/*::]*/: { n:"UsrInfo" },
	/*::[*/0x0194/*::]*/: { n:"UsrExcl" },
	/*::[*/0x0195/*::]*/: { n:"FileLock" },
	/*::[*/0x0196/*::]*/: { n:"RRDInfo" },
	/*::[*/0x0197/*::]*/: { n:"BCUsrs" },
	/*::[*/0x0198/*::]*/: { n:"UsrChk" },
	/*::[*/0x01a9/*::]*/: { n:"UserBView" },
	/*::[*/0x01aa/*::]*/: { n:"UserSViewBegin" },
	/*::[*/0x01ab/*::]*/: { n:"UserSViewEnd" },
	/*::[*/0x01ac/*::]*/: { n:"RRDUserView" },
	/*::[*/0x01ad/*::]*/: { n:"Qsi" },
	/*::[*/0x01ae/*::]*/: { n:"SupBook", f:parse_SupBook },
	/*::[*/0x01af/*::]*/: { n:"Prot4Rev", f:parsebool },
	/*::[*/0x01b0/*::]*/: { n:"CondFmt" },
	/*::[*/0x01b1/*::]*/: { n:"CF" },
	/*::[*/0x01b2/*::]*/: { n:"DVal" },
	/*::[*/0x01b5/*::]*/: { n:"DConBin" },
	/*::[*/0x01b6/*::]*/: { n:"TxO", f:parse_TxO },
	/*::[*/0x01b7/*::]*/: { n:"RefreshAll", f:parsebool },
	/*::[*/0x01b8/*::]*/: { n:"HLink", f:parse_HLink },
	/*::[*/0x01b9/*::]*/: { n:"Lel" },
	/*::[*/0x01ba/*::]*/: { n:"CodeName", f:parse_XLUnicodeString },
	/*::[*/0x01bb/*::]*/: { n:"SXFDBType" },
	/*::[*/0x01bc/*::]*/: { n:"Prot4RevPass", f:parseuint16 },
	/*::[*/0x01bd/*::]*/: { n:"ObNoMacros" },
	/*::[*/0x01be/*::]*/: { n:"Dv" },
	/*::[*/0x01c0/*::]*/: { n:"Excel9File", f:parsenoop2 },
	/*::[*/0x01c1/*::]*/: { n:"RecalcId", f:parse_RecalcId, r:2},
	/*::[*/0x01c2/*::]*/: { n:"EntExU2", f:parsenoop2 },
	/*::[*/0x0200/*::]*/: { n:"Dimensions", f:parse_Dimensions },
	/*::[*/0x0201/*::]*/: { n:"Blank", f:parse_Blank },
	/*::[*/0x0203/*::]*/: { n:"Number", f:parse_Number },
	/*::[*/0x0204/*::]*/: { n:"Label", f:parse_Label },
	/*::[*/0x0205/*::]*/: { n:"BoolErr", f:parse_BoolErr },
	/*::[*/0x0207/*::]*/: { n:"String", f:parse_String },
	/*::[*/0x0208/*::]*/: { n:'Row', f:parse_Row },
	/*::[*/0x020b/*::]*/: { n:"Index" },
	/*::[*/0x0221/*::]*/: { n:"Array", f:parse_Array },
	/*::[*/0x0225/*::]*/: { n:"DefaultRowHeight", f:parse_DefaultRowHeight },
	/*::[*/0x0236/*::]*/: { n:"Table" },
	/*::[*/0x023e/*::]*/: { n:"Window2", f:parse_Window2 },
	/*::[*/0x027e/*::]*/: { n:"RK", f:parse_RK },
	/*::[*/0x0293/*::]*/: { n:"Style" },
	/*::[*/0x0418/*::]*/: { n:"BigName" },
	/*::[*/0x041e/*::]*/: { n:"Format", f:parse_Format },
	/*::[*/0x043c/*::]*/: { n:"ContinueBigName" },
	/*::[*/0x04bc/*::]*/: { n:"ShrFmla", f:parse_ShrFmla },
	/*::[*/0x0800/*::]*/: { n:"HLinkTooltip", f:parse_HLinkTooltip },
	/*::[*/0x0801/*::]*/: { n:"WebPub" },
	/*::[*/0x0802/*::]*/: { n:"QsiSXTag" },
	/*::[*/0x0803/*::]*/: { n:"DBQueryExt" },
	/*::[*/0x0804/*::]*/: { n:"ExtString" },
	/*::[*/0x0805/*::]*/: { n:"TxtQry" },
	/*::[*/0x0806/*::]*/: { n:"Qsir" },
	/*::[*/0x0807/*::]*/: { n:"Qsif" },
	/*::[*/0x0808/*::]*/: { n:"RRDTQSIF" },
	/*::[*/0x0809/*::]*/: { n:'BOF', f:parse_BOF },
	/*::[*/0x080a/*::]*/: { n:"OleDbConn" },
	/*::[*/0x080b/*::]*/: { n:"WOpt" },
	/*::[*/0x080c/*::]*/: { n:"SXViewEx" },
	/*::[*/0x080d/*::]*/: { n:"SXTH" },
	/*::[*/0x080e/*::]*/: { n:"SXPIEx" },
	/*::[*/0x080f/*::]*/: { n:"SXVDTEx" },
	/*::[*/0x0810/*::]*/: { n:"SXViewEx9" },
	/*::[*/0x0812/*::]*/: { n:"ContinueFrt" },
	/*::[*/0x0813/*::]*/: { n:"RealTimeData" },
	/*::[*/0x0850/*::]*/: { n:"ChartFrtInfo" },
	/*::[*/0x0851/*::]*/: { n:"FrtWrapper" },
	/*::[*/0x0852/*::]*/: { n:"StartBlock" },
	/*::[*/0x0853/*::]*/: { n:"EndBlock" },
	/*::[*/0x0854/*::]*/: { n:"StartObject" },
	/*::[*/0x0855/*::]*/: { n:"EndObject" },
	/*::[*/0x0856/*::]*/: { n:"CatLab" },
	/*::[*/0x0857/*::]*/: { n:"YMult" },
	/*::[*/0x0858/*::]*/: { n:"SXViewLink" },
	/*::[*/0x0859/*::]*/: { n:"PivotChartBits" },
	/*::[*/0x085a/*::]*/: { n:"FrtFontList" },
	/*::[*/0x0862/*::]*/: { n:"SheetExt" },
	/*::[*/0x0863/*::]*/: { n:"BookExt", r:12},
	/*::[*/0x0864/*::]*/: { n:"SXAddl" },
	/*::[*/0x0865/*::]*/: { n:"CrErr" },
	/*::[*/0x0866/*::]*/: { n:"HFPicture" },
	/*::[*/0x0867/*::]*/: { n:'FeatHdr', f:parsenoop2 },
	/*::[*/0x0868/*::]*/: { n:"Feat" },
	/*::[*/0x086a/*::]*/: { n:"DataLabExt" },
	/*::[*/0x086b/*::]*/: { n:"DataLabExtContents" },
	/*::[*/0x086c/*::]*/: { n:"CellWatch" },
	/*::[*/0x0871/*::]*/: { n:"FeatHdr11" },
	/*::[*/0x0872/*::]*/: { n:"Feature11" },
	/*::[*/0x0874/*::]*/: { n:"DropDownObjIds" },
	/*::[*/0x0875/*::]*/: { n:"ContinueFrt11" },
	/*::[*/0x0876/*::]*/: { n:"DConn" },
	/*::[*/0x0877/*::]*/: { n:"List12" },
	/*::[*/0x0878/*::]*/: { n:"Feature12" },
	/*::[*/0x0879/*::]*/: { n:"CondFmt12" },
	/*::[*/0x087a/*::]*/: { n:"CF12" },
	/*::[*/0x087b/*::]*/: { n:"CFEx" },
	/*::[*/0x087c/*::]*/: { n:"XFCRC", f:parse_XFCRC, r:12 },
	/*::[*/0x087d/*::]*/: { n:"XFExt", f:parse_XFExt, r:12 },
	/*::[*/0x087e/*::]*/: { n:"AutoFilter12" },
	/*::[*/0x087f/*::]*/: { n:"ContinueFrt12" },
	/*::[*/0x0884/*::]*/: { n:"MDTInfo" },
	/*::[*/0x0885/*::]*/: { n:"MDXStr" },
	/*::[*/0x0886/*::]*/: { n:"MDXTuple" },
	/*::[*/0x0887/*::]*/: { n:"MDXSet" },
	/*::[*/0x0888/*::]*/: { n:"MDXProp" },
	/*::[*/0x0889/*::]*/: { n:"MDXKPI" },
	/*::[*/0x088a/*::]*/: { n:"MDB" },
	/*::[*/0x088b/*::]*/: { n:"PLV" },
	/*::[*/0x088c/*::]*/: { n:"Compat12", f:parsebool, r:12 },
	/*::[*/0x088d/*::]*/: { n:"DXF" },
	/*::[*/0x088e/*::]*/: { n:"TableStyles", r:12 },
	/*::[*/0x088f/*::]*/: { n:"TableStyle" },
	/*::[*/0x0890/*::]*/: { n:"TableStyleElement" },
	/*::[*/0x0892/*::]*/: { n:"StyleExt" },
	/*::[*/0x0893/*::]*/: { n:"NamePublish" },
	/*::[*/0x0894/*::]*/: { n:"NameCmt", f:parse_NameCmt, r:12 },
	/*::[*/0x0895/*::]*/: { n:"SortData" },
	/*::[*/0x0896/*::]*/: { n:"Theme", f:parse_Theme, r:12 },
	/*::[*/0x0897/*::]*/: { n:"GUIDTypeLib" },
	/*::[*/0x0898/*::]*/: { n:"FnGrp12" },
	/*::[*/0x0899/*::]*/: { n:"NameFnGrp12" },
	/*::[*/0x089a/*::]*/: { n:"MTRSettings", f:parse_MTRSettings, r:12 },
	/*::[*/0x089b/*::]*/: { n:"CompressPictures", f:parsenoop2 },
	/*::[*/0x089c/*::]*/: { n:"HeaderFooter" },
	/*::[*/0x089d/*::]*/: { n:"CrtLayout12" },
	/*::[*/0x089e/*::]*/: { n:"CrtMlFrt" },
	/*::[*/0x089f/*::]*/: { n:"CrtMlFrtContinue" },
	/*::[*/0x08a3/*::]*/: { n:"ForceFullCalculation", f:parse_ForceFullCalculation },
	/*::[*/0x08a4/*::]*/: { n:"ShapePropsStream" },
	/*::[*/0x08a5/*::]*/: { n:"TextPropsStream" },
	/*::[*/0x08a6/*::]*/: { n:"RichTextStream" },
	/*::[*/0x08a7/*::]*/: { n:"CrtLayout12A" },
	/*::[*/0x1001/*::]*/: { n:"Units" },
	/*::[*/0x1002/*::]*/: { n:"Chart" },
	/*::[*/0x1003/*::]*/: { n:"Series" },
	/*::[*/0x1006/*::]*/: { n:"DataFormat" },
	/*::[*/0x1007/*::]*/: { n:"LineFormat" },
	/*::[*/0x1009/*::]*/: { n:"MarkerFormat" },
	/*::[*/0x100a/*::]*/: { n:"AreaFormat" },
	/*::[*/0x100b/*::]*/: { n:"PieFormat" },
	/*::[*/0x100c/*::]*/: { n:"AttachedLabel" },
	/*::[*/0x100d/*::]*/: { n:"SeriesText" },
	/*::[*/0x1014/*::]*/: { n:"ChartFormat" },
	/*::[*/0x1015/*::]*/: { n:"Legend" },
	/*::[*/0x1016/*::]*/: { n:"SeriesList" },
	/*::[*/0x1017/*::]*/: { n:"Bar" },
	/*::[*/0x1018/*::]*/: { n:"Line" },
	/*::[*/0x1019/*::]*/: { n:"Pie" },
	/*::[*/0x101a/*::]*/: { n:"Area" },
	/*::[*/0x101b/*::]*/: { n:"Scatter" },
	/*::[*/0x101c/*::]*/: { n:"CrtLine" },
	/*::[*/0x101d/*::]*/: { n:"Axis" },
	/*::[*/0x101e/*::]*/: { n:"Tick" },
	/*::[*/0x101f/*::]*/: { n:"ValueRange" },
	/*::[*/0x1020/*::]*/: { n:"CatSerRange" },
	/*::[*/0x1021/*::]*/: { n:"AxisLine" },
	/*::[*/0x1022/*::]*/: { n:"CrtLink" },
	/*::[*/0x1024/*::]*/: { n:"DefaultText" },
	/*::[*/0x1025/*::]*/: { n:"Text" },
	/*::[*/0x1026/*::]*/: { n:"FontX", f:parseuint16 },
	/*::[*/0x1027/*::]*/: { n:"ObjectLink" },
	/*::[*/0x1032/*::]*/: { n:"Frame" },
	/*::[*/0x1033/*::]*/: { n:"Begin" },
	/*::[*/0x1034/*::]*/: { n:"End" },
	/*::[*/0x1035/*::]*/: { n:"PlotArea" },
	/*::[*/0x103a/*::]*/: { n:"Chart3d" },
	/*::[*/0x103c/*::]*/: { n:"PicF" },
	/*::[*/0x103d/*::]*/: { n:"DropBar" },
	/*::[*/0x103e/*::]*/: { n:"Radar" },
	/*::[*/0x103f/*::]*/: { n:"Surf" },
	/*::[*/0x1040/*::]*/: { n:"RadarArea" },
	/*::[*/0x1041/*::]*/: { n:"AxisParent" },
	/*::[*/0x1043/*::]*/: { n:"LegendException" },
	/*::[*/0x1044/*::]*/: { n:"ShtProps", f:parse_ShtProps },
	/*::[*/0x1045/*::]*/: { n:"SerToCrt" },
	/*::[*/0x1046/*::]*/: { n:"AxesUsed" },
	/*::[*/0x1048/*::]*/: { n:"SBaseRef" },
	/*::[*/0x104a/*::]*/: { n:"SerParent" },
	/*::[*/0x104b/*::]*/: { n:"SerAuxTrend" },
	/*::[*/0x104e/*::]*/: { n:"IFmtRecord" },
	/*::[*/0x104f/*::]*/: { n:"Pos" },
	/*::[*/0x1050/*::]*/: { n:"AlRuns" },
	/*::[*/0x1051/*::]*/: { n:"BRAI" },
	/*::[*/0x105b/*::]*/: { n:"SerAuxErrBar" },
	/*::[*/0x105c/*::]*/: { n:"ClrtClient", f:parse_ClrtClient },
	/*::[*/0x105d/*::]*/: { n:"SerFmt" },
	/*::[*/0x105f/*::]*/: { n:"Chart3DBarShape" },
	/*::[*/0x1060/*::]*/: { n:"Fbi" },
	/*::[*/0x1061/*::]*/: { n:"BopPop" },
	/*::[*/0x1062/*::]*/: { n:"AxcExt" },
	/*::[*/0x1063/*::]*/: { n:"Dat" },
	/*::[*/0x1064/*::]*/: { n:"PlotGrowth" },
	/*::[*/0x1065/*::]*/: { n:"SIIndex" },
	/*::[*/0x1066/*::]*/: { n:"GelFrame" },
	/*::[*/0x1067/*::]*/: { n:"BopPopCustom" },
	/*::[*/0x1068/*::]*/: { n:"Fbi2" },

	/*::[*/0x0000/*::]*/: { n:"Dimensions", f:parse_Dimensions },
	/*::[*/0x0001/*::]*/: { n:"BIFF2BLANK" },
	/*::[*/0x0002/*::]*/: { n:"BIFF2INT", f:parse_BIFF2INT },
	/*::[*/0x0003/*::]*/: { n:"BIFF2NUM", f:parse_BIFF2NUM },
	/*::[*/0x0004/*::]*/: { n:"BIFF2STR", f:parse_BIFF2STR },
	/*::[*/0x0005/*::]*/: { n:"BoolErr", f:parse_BoolErr },
	/*::[*/0x0007/*::]*/: { n:"String", f:parse_BIFF2STRING },
	/*::[*/0x0008/*::]*/: { n:"BIFF2ROW" },
	/*::[*/0x0009/*::]*/: { n:'BOF', f:parse_BOF },
	/*::[*/0x000b/*::]*/: { n:"Index" },
	/*::[*/0x0016/*::]*/: { n:"ExternCount", f:parseuint16 },
	/*::[*/0x001e/*::]*/: { n:"BIFF2FORMAT", f:parse_BIFF2Format },
	/*::[*/0x001f/*::]*/: { n:"BIFF2FMTCNT" }, /* 16-bit cnt of BIFF2FORMAT records */
	/*::[*/0x0020/*::]*/: { n:"BIFF2COLINFO" },
	/*::[*/0x0021/*::]*/: { n:"Array", f:parse_Array },
	/*::[*/0x0024/*::]*/: { n:"COLWIDTH" },
	/*::[*/0x0025/*::]*/: { n:"DefaultRowHeight", f:parse_DefaultRowHeight },
	// 0x2c ??
	// 0x2d ??
	// 0x2e ??
	// 0x30 FONTCOUNT: number of fonts
	/*::[*/0x0032/*::]*/: { n:"BIFF2FONTXTRA", f:parse_BIFF2FONTXTRA },
	// 0x35: INFOOPTS
	// 0x36: TABLE (BIFF2 only)
	// 0x37: TABLE2 (BIFF2 only)
	// 0x38: WNDESK
	// 0x39 ??
	// 0x3a: BEGINPREF
	// 0x3b: ENDPREF
	/*::[*/0x003e/*::]*/: { n:"BIFF2WINDOW2" },
	// 0x3f ??
	// 0x46: SHOWSCROLL
	// 0x47: SHOWFORMULA
	// 0x48: STATUSBAR
	// 0x49: SHORTMENUS
	// 0x4A:
	// 0x4B:
	// 0x4C:
	// 0x4E:
	// 0x4F:
	// 0x58: TOOLBAR (BIFF3)

	/* - - - */
	/*::[*/0x0034/*::]*/: { n:"DDEObjName" },
	/*::[*/0x0043/*::]*/: { n:"BIFF2XF" },
	/*::[*/0x0044/*::]*/: { n:"BIFF2XFINDEX", f:parseuint16 },
	/*::[*/0x0045/*::]*/: { n:"BIFF2FONTCLR" },
	/*::[*/0x0056/*::]*/: { n:"BIFF4FMTCNT" }, /* 16-bit cnt, similar to BIFF2 */
	/*::[*/0x007e/*::]*/: { n:"RK" }, /* Not necessarily same as 0x027e */
	/*::[*/0x007f/*::]*/: { n:"ImData", f:parse_ImData },
	/*::[*/0x0087/*::]*/: { n:"Addin" },
	/*::[*/0x0088/*::]*/: { n:"Edg" },
	/*::[*/0x0089/*::]*/: { n:"Pub" },
	// 0x8A
	// 0x8B LH: alternate menu key flag (BIFF3/4)
	// 0x8E
	// 0x8F
	/*::[*/0x0091/*::]*/: { n:"Sub" },
	// 0x93 STYLE
	/*::[*/0x0094/*::]*/: { n:"LHRecord" },
	/*::[*/0x0095/*::]*/: { n:"LHNGraph" },
	/*::[*/0x0096/*::]*/: { n:"Sound" },
	// 0xA2 FNPROTO: function prototypes (BIFF4)
	// 0xA3
	// 0xA8
	/*::[*/0x00a9/*::]*/: { n:"CoordList" },
	/*::[*/0x00ab/*::]*/: { n:"GCW" },
	/*::[*/0x00bc/*::]*/: { n:"ShrFmla" }, /* Not necessarily same as 0x04bc */
	/*::[*/0x00bf/*::]*/: { n:"ToolbarHdr" },
	/*::[*/0x00c0/*::]*/: { n:"ToolbarEnd" },
	/*::[*/0x00c2/*::]*/: { n:"AddMenu" },
	/*::[*/0x00c3/*::]*/: { n:"DelMenu" },
	/*::[*/0x00d6/*::]*/: { n:"RString", f:parse_RString },
	/*::[*/0x00df/*::]*/: { n:"UDDesc" },
	/*::[*/0x00ea/*::]*/: { n:"TabIdConf" },
	/*::[*/0x0162/*::]*/: { n:"XL5Modify" },
	/*::[*/0x01a5/*::]*/: { n:"FileSharing2" },
	/*::[*/0x0206/*::]*/: { n:"Formula", f:parse_Formula },
	/*::[*/0x0209/*::]*/: { n:'BOF', f:parse_BOF },
	/*::[*/0x0218/*::]*/: { n:"Lbl", f:parse_Lbl },
	/*::[*/0x0223/*::]*/: { n:"ExternName", f:parse_ExternName },
	/*::[*/0x0231/*::]*/: { n:"Font" },
	/*::[*/0x0243/*::]*/: { n:"BIFF3XF" },
	/*::[*/0x0406/*::]*/: { n:"Formula", f:parse_Formula },
	/*::[*/0x0409/*::]*/: { n:'BOF', f:parse_BOF },
	/*::[*/0x0443/*::]*/: { n:"BIFF4XF" },
	/*::[*/0x086d/*::]*/: { n:"FeatInfo" },
	/*::[*/0x0873/*::]*/: { n:"FeatInfo11" },
	/*::[*/0x0881/*::]*/: { n:"SXAddl12" },
	/*::[*/0x08c0/*::]*/: { n:"AutoWebPub" },
	/*::[*/0x08c1/*::]*/: { n:"ListObj" },
	/*::[*/0x08c2/*::]*/: { n:"ListField" },
	/*::[*/0x08c3/*::]*/: { n:"ListDV" },
	/*::[*/0x08c4/*::]*/: { n:"ListCondFmt" },
	/*::[*/0x08c5/*::]*/: { n:"ListCF" },
	/*::[*/0x08c6/*::]*/: { n:"FMQry" },
	/*::[*/0x08c7/*::]*/: { n:"FMSQry" },
	/*::[*/0x08c8/*::]*/: { n:"PLV" },
	/*::[*/0x08c9/*::]*/: { n:"LnExt" },
	/*::[*/0x08ca/*::]*/: { n:"MkrExt" },
	/*::[*/0x08cb/*::]*/: { n:"CrtCoopt" },
	/*::[*/0x08d6/*::]*/: { n:"FRTArchId$", r:12 },

	/*::[*/0x7262/*::]*/: {}
};

var XLSRE = evert_key(XLSRecordEnum, 'n');
